#if defined(LINUX) || defined(INTERIX) || defined(CYGWIN)  || defined(SCOUNX)
/* for abstract data types (struct that we use only as pointers),
   gcc on linux, and most other compilers, will let us squelch
   those silly warnings if we declare the struct with no memebers.
   It's a kind of "forward" declaration...
*/

struct _S_SQCURSOR;
struct sqlda;
struct sqlvar_struct;

#endif

extern void __cdecl main(int argc,char **argv );
static int __cdecl evalargs(int argc,char **argv ,char **dbname ,char *sqlscript);
static void __cdecl usagerr(char *prog);
static int __cdecl do_cursor(struct _S_SQCURSOR *sqc);
static void __cdecl do_stmt(struct _S_SQCURSOR *sqc,char *sqlcmdbuf);
static int __cdecl dspl_anyerr(struct _S_SQCURSOR *sqc);
static void __cdecl pr_cmd(char *cmd,int len);
static void __cdecl fxsqlexit(int sts);
static char *__cdecl sqlopen(char *fname,char *ftype);
static int __cdecl sqlclose(char *cfs);
static int __cdecl sel_hdr(struct _S_SQCURSOR *sqc,struct sqlda *qdesc);
static void __cdecl pr_selline(struct sqlda *q_desc);
static void __cdecl pr_flddata(struct sqlvar_struct *qv,char *dbuf,int fldno);
static void __cdecl pr_vertfld(char *str,int len);
extern int __cdecl getrptwidth(char *sqlname,short sqltype,short sqllen);
static int __cdecl getwidth(short sqltype,short sqllen);
static int __cdecl testfield(char *sqlname,short sqltype);
