#if defined(LINUX) || defined(INTERIX) || defined(CYGWIN)  || defined(SCOUNX)
/* for abstract data types (struct that we use only as pointers),
   gcc on linux, and most other compilers, will let us squelch
   those silly warnings if we declare the struct with no memebers.
   It's a kind of "forward" declaration...
*/

struct _S_RWFILE;
struct dtime;

#endif

extern short __cdecl fx_to_sqltyp(short fxtype);
extern short __cdecl sqlda_to_ctyp(short sqltype);
extern short __cdecl sqlda_to_fxtyp(short qtype);
extern int __cdecl dtcvasc(char *str,struct dtime *d);
extern int __cdecl dttoasc(struct dtime *d,char *str);
extern int __cdecl dtcmp(struct dtime *dt1,struct dtime *dt2);
extern char *__cdecl dtqualname(int qualnum);
extern long __cdecl daysinyrs(short delta);
extern void __cdecl initsqlca(void);
extern void __cdecl ph1err(int eno);
extern void __cdecl ph1errmsg(char *msg,int eno);
extern void __cdecl errsqlca(int eno);
extern void __cdecl errmsgsqlca(char *msg,int eno);
extern void __cdecl warn_err(char *msg,int eno);
extern void __cdecl set_sqlcode(int eno);
extern int __cdecl fright(char *buffer,int length);
extern void __cdecl fleft(char *buffer,int length);
extern int __cdecl rdatestr(long in,char *out);
extern char *__cdecl getdbdate(int *dlen);
extern int __cdecl rdayofweek(long jdate);
extern int __cdecl rdefmtdate(long *numdate,char *format,char *sdate);
static int __cdecl getdatetype(char *format);
extern void __cdecl sqlnameshift(char *s,int len);
extern void __cdecl downshift(char *s,int len);
extern int __cdecl rfmtdate(long in,char *format,char *out);
extern int __cdecl rfmtlong(long lvalue,char *format,char *outbuf);
extern int __cdecl rfmtdec(struct decimal *dec,char *format,char *outbuf);
extern int __cdecl rfmtdouble(double dvalue,char *format,char *outbuf);
static void __cdecl sethipos(int fi,int numpref);
static void __cdecl overflow(char *format,char *outbuf,int ftlen);
extern int __cdecl msgopen(void);
extern void __cdecl msgclose(void);
extern char *__cdecl loadmsg(int msgno);
extern int __cdecl rgetmsg(short msgno,char *msgstr, short maxmsglen);
extern int __cdecl rgetlmsg(long msgno,char *msgstr,int maxmsglen,int *msglen);
static char *__cdecl getarg(char *pbuf);
extern int __cdecl risnull(int ctype,char *buffer);
extern int __cdecl isbufnull(short typ,char *buffer);
extern int __cdecl sqisnull(char *buffer,int fxtype,int buftype);
extern int __cdecl rjulmdy(long n,short *mdy);
extern int __cdecl rleapyear(int y);
extern int __cdecl rmdyjul(short *mdy,long *numdate);
extern void __cdecl rsetnull(int ctype,char *cvarp);
extern int __cdecl dfsetnull(struct _S_DBFIELD *fp);
extern void __cdecl sqsetnull(char *buffer,int type,int length,int buftype);
extern void __cdecl sqsetzero(char *buffer,int type,int length,int buftype);
extern int __cdecl rstrdate(char *indate,long *numdate);
extern int __cdecl idatebytyp(char *indate,long *numdate,int type);
static int __cdecl dateorder(int *dayindex,int *monthindex,int *yearindex,int type);
extern void __cdecl rtoday(long *numdate);
extern void __cdecl sysdate(char *datebuf);
extern int __cdecl rtypalign(int pos,int type);
extern int __cdecl rtypmsize(int sqltype,int sqllen);
extern int __cdecl rtypwidth(int sqltype,int sqllen);
extern void __cdecl rupshift(char *s);
extern int __cdecl defmtdbdate(char *sdate,long *ndate);
extern int __cdecl fmopen(struct _S_DBHEAD *pdbhead,int ismode);
static int __cdecl fmclosold(void);
extern int __cdecl fmclose(struct _S_DBHEAD *pdbhead);
extern int __cdecl fmclos2(struct _S_DBHEAD *pdbhead,int fd);
extern int __cdecl fmfind(struct _S_DBHEAD *pdbhead,struct _S_DBINDEX *pdbindex,int mode);
extern int __cdecl fmread(struct _S_DBHEAD *pdbhead,int mode);
static int __cdecl fmisread(struct _S_DBHEAD *pdbhead,int mode);
extern int __cdecl fmrwread(struct _S_DBHEAD *pdbhead);
extern int __cdecl fmwrite(struct _S_DBHEAD *pdbhead);
extern int __cdecl fmrewcurr(struct _S_DBHEAD *pdbhead);
extern int __cdecl fmrewrec(struct _S_DBHEAD *pdbhead);
extern int __cdecl fmdelcurr(struct _S_DBHEAD *pdbhead);
extern int __cdecl fmstart(struct _S_DBHEAD *pdbhead,struct _S_DBINDEX *pdbindex,int length,int mode);
extern int __cdecl fmdictinfo(struct _S_DBHEAD *pdbhead,struct dictinfo *pdictinfo);
extern int __cdecl fmindexinfo(struct _S_DBHEAD *pdbhead,struct _S_DBINDEX *pdbindex,struct keydesc *pkeydesc);
extern int __cdecl fmbuild(struct _S_DBHEAD *pdbhead,struct _S_DBINDEX *pdbindex,int ismode);
extern void __cdecl sqbuildall(struct _S_DBHEAD *pdbhead);
extern int __cdecl fmerase(struct _S_DBHEAD *pdbhead);
extern int __cdecl fmrename(char *oldname,char *newname);
extern int __cdecl fmlock(struct _S_DBHEAD *pdbhead);
extern int __cdecl fmunlock(struct _S_DBHEAD *pdbhead);
extern int __cdecl fmaddindex(struct _S_DBHEAD *pdbhead,struct _S_DBINDEX *pdbindex);
extern int __cdecl fmdelindex(struct _S_DBHEAD *pdbhead,struct _S_DBINDEX *pdbindex);
extern int __cdecl fmuniqueid(struct _S_DBHEAD *pdbhead,long *recnum);
extern int __cdecl fmsetunique(struct _S_DBHEAD *pdbhead,long recnum);
extern void __cdecl fmsetserial(struct _S_DBHEAD *pdbhead);
extern void __cdecl fmcurclr(struct _S_DBHEAD *pdbhead);
extern void __cdecl fmcurset(struct _S_DBHEAD *pdbhead);
extern void __cdecl fmisaminit(void);
extern int __cdecl fmrwopen(struct _S_DBHEAD *pdbhead,int ismode);
extern int __cdecl fmrwclose(struct _S_DBHEAD *pdbhead);
extern int __cdecl fmcluster(struct _S_DBHEAD *pdbhead,struct _S_DBINDEX *pdbindex);
static void __cdecl fmsetview(struct _S_DBHEAD *pdbhead,char *pstruct,int oper);
static int __cdecl sqsetstruct(struct _S_DBHEAD *pdbhead,char *pstruct,int oper);
extern int __cdecl fmisintrp(void);
extern int __cdecl bldkeydesc(struct _S_DBHEAD *pdbhead,struct _S_DBINDEX *pdbindex,struct keydesc *pkeydesc);
extern int __cdecl fmstructview(struct _S_DBHEAD *pdbhead,struct dbview *pdbview,int vwnum,char *vwstruct);
extern void __cdecl fmtdouble(char *outbuf,double dvalue,int length,int dec);
extern double __cdecl dblround(double x,unsigned int nplaces);
extern int __cdecl buftostr(char *s1,char *s2,int type,int length,int dec,int fmt);
extern int __cdecl fcomma(char *buffer,int length);
extern struct _S_DBHEAD *__cdecl getdhp(char *name);
extern struct _S_DBHEAD *__cdecl getdhpath(char *name);
extern struct _S_DBFIELD *__cdecl getdfp(struct _S_DBHEAD *pdbhead,char *name);
extern struct _S_DBINDEX *__cdecl getdip(struct _S_DBHEAD *pdbhead,char *name);
extern struct _S_DBFIELD *__cdecl getdidfp(struct _S_DBINDEX *pdbindex,int partno);
static int __cdecl geterr(char *pgname,char *name);
extern void __cdecl errorlevel(int flag);
extern int __cdecl whaterrlvl(void);
extern char *__cdecl getdfbuf(struct _S_DBFIELD *pdbfield);
extern int __cdecl getpdhn(struct _S_DBHEAD *pdbhead);
extern int __cdecl getpdfn(struct _S_DBFIELD *pdbfield);
extern void __cdecl getdf(char *value,struct _S_DBFIELD *pdbfield);
extern void __cdecl getdfs(int type,int length,char *value,char *buffer);
extern int __cdecl putdf(char *value,struct _S_DBFIELD *pdbfield);
extern void __cdecl putdfs(int type,int length,char *value,char *buffer);
extern char *__cdecl bufalloc(char *dbuf,unsigned int *allocsiz,int reqsiz,char *func);
extern int __cdecl mktblpath(char *pathname,char *filename);
extern int __cdecl mkpath(char *pathname,char *dirpath,char *filename);
extern void __cdecl dclrrec(struct _S_DBHEAD *pdbhead);
extern void __cdecl dclrrng(struct _S_DBFIELD *pdbfirst,struct _S_DBFIELD *pdblast);
extern void __cdecl rmovchar(char *srcbuf,int srclen,char *destbuf,int destlen);
extern void __cdecl wmovchar(char *srcbuf,int srclen,char *destbuf,int destlen);
extern void __cdecl movnum(char *srcbuf,int srclen,char *destbuf,int destlen);
extern void __cdecl movbin(char *srcbuf,int srclen,char *destbuf,int destlen);
extern void __cdecl rdshort(char *srcbuf,int srclen,char *destbuf,int destlen);
extern int __cdecl wdshort(char *srcbuf,int srclen,char *destbuf,int destlen);
extern void __cdecl rdlong(char *srcbuf,int srclen,char *destbuf,int destlen);
extern int __cdecl wdlong(char *srcbuf,int srclen,char *destbuf,int destlen);
extern void __cdecl rddbl(char *srcbuf,int srclen,char *destbuf,int destlen);
extern int __cdecl wddbl(char *srcbuf,int srclen,char *destbuf,int destlen);
extern void __cdecl rdfloat(char *srcbuf,int srclen,char *destbuf,int destlen);
extern int __cdecl wdfloat(char *srcbuf,int srclen,char *destbuf,int destlen);
extern void __cdecl rddtime(char *srcbuf,int srclen,char *destbuf,int destlen);
extern int __cdecl wddtime(char *srcbuf,int srclen,char *destbuf,int destlen);
extern void __cdecl rddec(char *srcbuf,int srclen,char *destbuf,int destlen);
extern int __cdecl rddecdbl(char *srcbuf,int srclen,char *destbuf,int destlen);
extern int __cdecl wddec(char *srcbuf,int srclen,char *destbuf,int destlen);
extern int __cdecl wddecdbl(char *srcbuf,int srclen,char *destbuf,int destlen);
extern int __cdecl rdmoney(char *srcbuf,int srclen,char *destbuf,int destlen);
extern int __cdecl wdmoney(char *srcbuf,int srclen,char *destbuf,int destlen);
extern void __cdecl prsqldb(int fd,struct _S_DBHEAD *pdbhead);
extern void __cdecl prhdhead(int fd,struct _S_HDHEAD *phdhead,int maxnum);
extern void __cdecl prdbhead(int fd,struct _S_DBHEAD *pdbhead,int maxnum);
extern void __cdecl prdbfield(int fd,struct _S_DBFIELD *pdbfield,int maxnum);
extern void __cdecl prdbindex(int fd,struct _S_DBINDEX *pdbindex,int maxnum);
extern void __cdecl prdbrec(int fd,struct _S_DBHEAD *tp);
extern void __cdecl prfld(int fd,struct _S_DBFIELD *fp);
extern void __cdecl prdhbuf(int fd,struct _S_DBHEAD *tp);
extern void __cdecl prkeydesc(int fd,struct keydesc *kd,char *dbuf,int indent);
extern void __cdecl prdictinfo(int fd,struct dictinfo *pdict,int indent);
extern void __cdecl prjmpenv(int fd);
extern int __cdecl rwopen(char *pathname,char *mode,long lastrecnum);
extern int __cdecl rwputlist(int fd,long lastrecnum);
extern int __cdecl rwclose(int filenum);
extern long __cdecl rwtell(int filenum);
extern long __cdecl rwseek(int filenum,long offset,int origin);
extern char *__cdecl rwgets(char *s,int n,int filenum);
extern int __cdecl rwgetc(int filenum);
extern int __cdecl rwread(int filenum,char *prwbuf,unsigned int size);
extern int __cdecl rwputs(int filenum,char *s);
extern int __cdecl rwwrite(int filenum,char *prwbuf,unsigned int size);
extern long __cdecl rwincreccnt(int filenum);
static int __cdecl rwchkfilenum(int filenum,char *funcname);
extern int __cdecl backseek(char *cfs,char *str);
static void __cdecl dump_rwfile(struct _S_RWFILE *prwf);
extern short __cdecl sq_ldshort(char *pad);
extern int __cdecl sq_stshort(short val,char *pad);
extern int __cdecl sq_ldint(char *pad);
extern int __cdecl sq_stint(int val,char *pad);
extern long __cdecl sq_ldlong(char *pad);
extern int __cdecl sq_stlong(long val,char *pad);
extern int __cdecl sq_stchar(char *src,char *dest,int size);
extern float __cdecl sq_ldfloat(char *p);
extern int __cdecl sq_stfloat(float d,char *p);
extern double __cdecl sq_lddbl(char *p);
extern int __cdecl sq_stdbl(double d,char *p);
extern int __cdecl fxmemcmp(char *buffer1,char *buffer2,int count);
extern int __cdecl sqstrcmp(char *p1,char *p2);
extern int __cdecl nocasecmp(char *s1,char *s2,short len);
extern char *__cdecl strtrim(char *s,int c);
extern char *__cdecl sqstrfind(char *s,char *t,int (__cdecl *comp)(char *,char *,int ));
extern void __cdecl fxltoa(long n,char *s);
static int __cdecl reverse(char *s);
extern void __cdecl strcenter(char *s,int totlen);
extern void __cdecl swapbuf(char *p1,char *p2,int len);
extern int __cdecl creatargs(char *cmdline,char **argv ,int maxargc);
extern void __cdecl load_syscat(void);
extern void __cdecl sysopen(int lockmode);
extern void __cdecl sysstruct(void);
extern void __cdecl sysclose(void);
extern void __cdecl sysunlock(int eno);
extern struct _S_DBHEAD *__cdecl fmtable(char *tablename,char *owner,int chktemp,int unlksys);
static int __cdecl fmfld(struct _S_DBHEAD *pdbhead,char *tablename);
extern int __cdecl findstbl(char *tablename,char *owner);
extern int __cdecl findsidx(char *indexname,long tabid,char *owner,short ownermatch);
extern int __cdecl findscol(char *colname,long tabid);
extern void __cdecl prstbl(int maxnum);
extern void __cdecl prscol(int maxnum);
extern void __cdecl prsidx(int maxnum);
extern struct _S_DBHEAD *__cdecl dfinsert(struct _S_DBHEAD *pdbhead,char *colbefore,char *colname,int coltype,int collength,int coldec,int colflag);
extern void __cdecl dfdelete(struct _S_DBHEAD *pdbhead,char *colname);
extern void __cdecl dfmodify(struct _S_DBHEAD *pdbhead,char *colname,int coltype,int collength,int coldec);
static int __cdecl tbupdptr(struct _S_DBHEAD *pdbhead,int strsize);
extern void __cdecl fmunload(void);
extern void __cdecl dhfree(struct _S_DBHEAD *pdbhead);
extern void __cdecl tmperase(void);
extern struct _S_DBHEAD *__cdecl tballoc(int nindexes,int ncols);
static struct _S_DBHEAD *__cdecl tbrealloc(struct _S_DBHEAD *pdbhead,int oldsize,int newsize);
extern void __cdecl tbfree(struct _S_DBHEAD *pdbhead);
extern int __cdecl tbbufalloc(struct _S_DBHEAD *pdbhead);
extern void __cdecl tbbuffree(struct _S_DBHEAD *pdbhead);
static int __cdecl putdhsize(struct _S_DBHEAD *pdbhead,int memsize);
static int __cdecl getdhsize(struct _S_DBHEAD *pdbhead);
extern void __cdecl inithead(struct _S_DBHEAD *pdbhead);
static int __cdecl initfield(struct _S_DBFIELD *pdbfield);
extern void __cdecl initindex(struct _S_DBINDEX *pdbindex);
extern int __cdecl rtimestr(long elapsecs,char *buffer,int type);
extern int __cdecl rstrtime(char *string,long *elapsecs,int type);
extern int __cdecl inittmplist(void);
extern int __cdecl addtmptbl(char *logictbl,char *disktbl);
extern void __cdecl mksqtmpnm(char *tmpname,int startno);
extern int __cdecl issqtmpnm(char *tblname);
extern struct _S_DBHEAD *__cdecl gettmphead(char *logictbl,int mkcopy);
extern struct _S_DBHEAD *__cdecl copydh(struct _S_DBHEAD *pdbhead);
extern int __cdecl istmptbl(char *logictbl);
extern int __cdecl gettmparri(char *tblname,int islogic);
extern void __cdecl addtmpidx(struct _S_DBINDEX *newdbindex);
extern int __cdecl deltmpidx(char *idxname);
extern int __cdecl istmpidx(char *idxname);
extern void __cdecl deltmptbl(char *logictbl);
extern void __cdecl prtmptbls(void);
extern int __cdecl trxstartlog(char *logfile,short dbcreate,short modeansi);
extern int __cdecl trxlogopen(char *logname,short chkansi);
extern int __cdecl trxlogclose(void);
extern int __cdecl trxlogname(char *logfile,char *dbdir);
extern int __cdecl trxbeginwrk(void);
extern int __cdecl ansibegwrk(void);
extern int __cdecl trxcommitwrk(void);
extern void __cdecl trxrollback(void);
extern int __cdecl trxrllbck_failok(void);
extern int __cdecl trxrfwddb(void);
extern void __cdecl vtsetnull(void);
extern int __cdecl sqiszero(char *buffer,int type,int length,int buftype);
extern int __cdecl getvwsize(int type,int length);
extern int __cdecl getpcksiz(int type,int qual);
extern int __cdecl getvtlen(int type,int flen,int qual);
extern int __cdecl getftype(char *fieldtype);
extern int __cdecl iswholenum(short dtype);
extern char *__cdecl strcompress(char *s);
static char *__cdecl strscan(char *s);
