#if defined()
/* for abstract data types (),
   gcc on linux, and most other compilers, will let us squelch
   those silly warnings if we declare the struct with no memebers.
   It's a kind of "forward" declaration...
*/

struct _S_DTFUNC; 
struct _S_FACTOR; 
struct _S_LIMITS; 
struct _S_SELINDEX; 
struct _S_SFIELD; 
struct _S_SQCURSOR; 
struct _S_SQSTMT; 
struct _S_TBLORD; 
struct _S_VALUE; 
struct _alloclist; 
struct _bfactor; 
struct _bracket; 
struct _dtexpr; 
struct _expr; 
struct _fldlist; 
struct _frmtbl; 
struct _hosthdr; 
struct _joinlst; 
struct _listv; 
struct _optiminfo; 
struct _ordfld; 
struct _select; 
struct _selflds; 
struct _sqlfield; 
struct _sqltbl; 
struct _structmap; 
struct _term; 
struct dtime; 
struct sqlda; 
struct sqlvar_struct; 

#endif

extern void prep_alter();
static void prp_tblalter();
static struct _S_DBHEAD *prp_aladd();
static int prp_aldrop();
static int prp_almodify();
extern void exc_tblalter();
static int _l_rewrite();
static int modcolauth();
static int sysrewrite();
static void fxconvert();
static int dffldtodbl();
static int dfdbltofld();
static void fldtodbl();
static void dbltofld();
extern void prp_idxalter();
extern void exc_idxalter();
extern void prep_create();
static int prp_crdbase();
extern char *getlogname();
extern void exc_crdbase();
static int bldsystbl();
static void fail_crdb();
static void prp_crtable();
static int getcoldef();
extern void exc_crtable();
static void prp_crindex();
extern void exc_crindex();
extern void exc_crsysidx();
extern void exc_crtmpidx();
static int syscreate();
static int syssetcnt();
extern void upd_nrow();
extern int pnet_string();
extern char *gnet_string();
extern int pnet_short();
extern int gnet_short();
extern int pnet_long();
extern int gnet_long();
extern int pnet_float();
extern int gnet_float();
extern int pnet_double();
extern int gnet_double();
extern int pnet_dec();
extern int gnet_dec();
extern int pnet_dtime();
extern int gnet_dtime();
extern int pnet_bool();
extern int gnet_bool();
extern int pnet_qdesc();
extern int gnet_qdesc();
extern int pnet_bind();
extern int gnet_bind();
extern int pnet_qdvar();
extern int gnet_qdvar();
extern int pnet_qddata();
extern int gnet_qddata();
extern int pnet_data();
extern int gnet_data();
extern int pnet_sqlca();
extern int gnet_sqlca();
extern int pnet_cmdtxt();
extern char **gnet_cmdtxt() ;
extern void free_bind();
extern void free_qdesc();
extern void free_cmdtxt();
static int net_read();
static int net_write();
extern int net_flush();
static int initcursmap();
extern struct _S_SQCURSOR *init_svsqc();
extern struct _S_SQCURSOR *get_svsqc();
extern void put_svbind();
extern void put_svibind();
extern void put_svobind();
extern int get_svbind();
extern void free_svbind();
extern void prep_dbase();
extern void getdbdir();
extern void mkdbpath();
extern int fxdatadb();
extern int exec_dbase();
extern void dbinit();
extern void dbfrompath();
extern int is_hostdb();
extern int prep_closedb();
extern void exec_closedb();
extern void prep_delete();
extern void del_stmt();
static int del_from();
extern void del_row();
extern struct _cond *chknest_cond();
static struct _cond *dist_bool();
static struct _bterm *link_fact();
static struct _cond *dist_not();
extern void initfacts();
extern void prep_drop();
static void prp_drdbase();
extern void exc_drdbase();
extern void rm_dir_files();
extern int is_dbfile();
static int prp_drtable();
extern void exc_drtable();
extern void delauthrecs();
static int prp_drindex();
extern void exc_drindex();
extern int ecpp_stmt();
extern int ecpp_db();
extern int ecpp_dclose();
extern int ecpp_close();
extern int ecpp_beginwk();
extern int ecpp_commitwk();
extern int ecpp_rollback();
extern int pr_stmnt();
extern int pp1_stmnt();
extern int pp2_stmnt();
extern int prstmtpart();
extern int sel_into();
extern int ppgetcurs();
extern int ecpp_hostv();
static int do_erase();
extern int _iqdatabase();
extern void _iqdbclose();
extern int _iqstmnt();
extern int _iqxecute();
extern int _iqeximm();
extern struct _hostv *init_host();
static int bindhosts();
static void obind_alloc();
extern int _iqslct();
extern int _iqprepare();
extern struct sqlda *init_sel_sqlda();
static int _iqprp2();
extern int _iqdscribe();
extern char *get_fhdr();
extern int _iqdclcur();
extern int _iqddclcur();
static int chk_decl();
extern int _iqcopen();
static void _iqcop2();
extern short ctyp_to_sqltyp();
extern int _iqnftch();
static long sqlda_tolng();
extern int _iqinsput();
extern int _iqclose();
extern int _iqclos2();
static int closeseltbls();
static struct _select *sel_refresh();
extern int _iqfree();
static int _iqfre2();
static int cmd_alloc();
static int cmd_free();
static int memp_alloc();
static int memp_free();
extern void pp_free();
static int sqc_check();
static struct _select *sel_sqcchk();
static int initjmpenv();
extern void ph2err();
extern void ph2errmsg();
extern int cl_database();
extern int cl_dbclose();
extern int cl_stmnt();
extern int cl_xecute();
extern int cl_eximm();
extern int cl_slct();
extern int cl_prepare();
extern int cl_dscribe();
extern int cl_dclcur();
extern int cl_ddclcur();
extern int cl_copen();
extern int cl_nftch();
extern int cl_insput();
extern int cl_close();
extern int cl_free();
extern int sqlstart();
extern int sqlexit();
extern int is_cltsrv();
extern void *GetFiberData();
extern void *GetCurrentFiber();
extern int sv_database();
extern int sv_dbclose();
extern int sv_stmnt();
extern int sv_xecute();
extern int sv_slct();
extern int sv_prepare();
extern int sv_dscribe();
extern int sv_dclcur();
extern int sv_ddclcur();
extern int sv_copen();
extern int sv_nftch();
extern int sv_insput();
extern int sv_close();
extern int sv_free();
extern void prep_explain();
extern void exec_explain();
extern void expl_stmt();
extern void expl_select();
extern void expl_table();
extern void expl_temps();
extern void expl_bracks();
static int expl_union();
static int expl_bfact();
static int expl_exp();
static int expl_term();
static int expl_fact();
static void expl_aggreg();
static int expl_fld();
static int expl_fname();
static int expl_dtexp();
static int expl_vlst();
extern void expl_val();
static int expl_subq();
static int prindent();
extern void expl_bop();
extern void expl_ismode();
extern void expl_text();
extern int expl_fileno();
static int equalbfacts();
extern char *getsqstmt();
extern struct _S_DBINDEX *xfindindex();
extern int comp_type();
extern int datafitfld();
static int getmagnitude();
static int getdecsize();
extern void prepsql();
extern void execsql();
static int prep_set();
extern void getcoltype();
extern short getdtqual();
static int dtqualifier();
extern void getdbname();
extern short get_dbpath();
extern void gettblname();
extern void getidxname();
extern short getownedobj();
extern void chkownedobjerr();
extern void getcolname();
extern void fld_list();
extern void setstbl();
extern void setscol();
extern void setsidx();
extern char *mkdskname();
extern void chk_intrp();
extern void prdatawarn();
extern void warnprompt();
extern char *sqlalloc();
static char *sqlallc2();
extern void parsefree();
extern void cursfree();
static void dynaoptfree();
static int sqlfree();
extern void testmem();
extern void do_info();
static void do_intables();
extern void do_inindexes();
extern void do_incolumns();
extern void prep_insert();
extern void ins_stmt();
static int val_list();
extern struct sqlda *init_ins_sqlda();
static int getinsval();
extern void chk_insert();
static void chk_insval();
extern void exec_insert();
extern void put_insert();
extern void open_instbl();
extern void setinssqlca();
extern void load_insert();
extern void insserial();
static int fmterr();
static int ldinserr();
extern void prep_ld();
extern void exec_ld();
extern void prp_setlckmd();
extern void exc_setlckmd();
extern void prep_lock();
extern void exec_lock();
extern void prep_unlock();
extern void exec_unlock();
extern int dopermute();
extern int docombo();
static int getpermute();
static int combo();
static int permute();
extern void dumpstmtid();
extern void dumpexptyp();
extern void dumpdattyp();
extern void dumpaggreg();
extern void dumpboolop();
extern void dumpsubqop();
extern void dumpistype();
extern void dumpdef();
extern void dumpbuf();
extern void prep_grant();
extern void prep_revoke();
static short getprivilege();
static void user_list();
static void user_name();
extern void exec_grant();
static void grant_tabpriv();
static int withgrantpriv();
extern void exec_revoke();
static void revk_tabpriv();
static int revk_fldpriv();
static void upd_dbpriv();
static void privwrite();
extern void getuserpriv();
extern long chk_tabpriv();
extern int chk_fldpriv();
static int auth_ok();
extern void dumpsqc();
extern int dumpqdesc();
extern int dumpsqlvars();
extern int do_rebuild();
static int rebuild();
extern void prep_rename();
extern void prp_rntable();
extern void exc_rntable();
static void prp_rncolumn();
extern void exc_rncolumn();
extern void copysellist();
extern void copycond();
static int cp2cond();
static int copybterm();
static int copyexp();
static int copyterm();
static int copydtexp();
extern void copyfldlist();
extern void remap_flds();
static int map_expflds();
static int map_whereflds();
static void map_listflds();
static void map_newfld();
static int map_fptr();
static int initcursorlist();
extern int addcursorlist();
extern int delcursorlist();
extern void curs_id();
static struct _S_SQCURSOR *getcrsptr();
extern char *getcrsnam();
extern void closenohold();
extern void exec_select();
extern int alwaysfalse();
extern struct _select *grpby_to_tmp();
extern void pretmpread();
extern int frmtbl_row();
extern int chk_lastagg();
static struct _select *bld_grpsel();
static struct _select *tmpselinit();
static int ftstart();
extern int next_row();
static int selread();
static int inbracket();
static int resetrows();
static int resetouter();
static int setoutnull();
static int outreadyout();
static int outotherout();
static int isoutparent();
static int resetbrack();
static int chk_gbreak();
static int switchgrpvals();
extern void sel_line();
extern void upd_line();
extern int updputdf();
static int pregrp_line();
extern void tmp_line();
static int out_line();
extern void starttmp();
extern int tmp_row();
static int val_to_fpunl();
static int nowriterr();
static int eval_bool();
static int evalbterm();
static int isoutnull();
static int isoutexp();
static int isoutterm();
extern int evalbfact();
static int evalposbf();
extern void subquery();
static short subselexec();
static struct _select *bld_subsel();
static int matchstr();
static int matchc();
extern int eval_exp();
extern int eval_term();
static int eval_fact();
static void eval_aggreg();
static int eval_dtfunc();
static int evaldate();
static void get_flddata();
static int ag_accum();
static void agac_exp();
static int agac_term();
static void agac_fact();
static void agac_cond();
static int agacbterm();
static int agacbfact();
extern int optimaggreg();
static int resettblcurs();
extern int fmtfield();
extern void setoptinfo();
extern struct _cond *setselopt();
extern void opt_info();
static void add_optinfo();
extern void init_optinfo();
extern struct _cond *chk_always();
static int chk_constexp();
static int set_bracket();
extern struct _bfactor *set_dynabrk();
extern int fldinbrack();
extern void brkfree();
static int brksvalfree();
static int brk_list();
static int add_bracket();
static int save_bracket();
static void save_opbrk();
static struct _bracket *link_brk();
static int new_begbrk();
static int new_endbrk();
static void find_endbrk();
static int simple_bool();
static int fldinexp();
static int fldinfact();
static int smple_exp();
static short revop();
static int brk_match();
static struct _listv *matchrange();
static struct _listv *list_match();
extern int isconstbrk();
extern int isdynabrk();
static int brkintersect();
extern struct _bfactor *brkunion();
static int brackinfact();
static int brk2union();
static struct _bracket *crtcopybrack();
extern void sel_stmt();
extern void query_spec();
extern short sel_clause();
static int sel_list();
extern int sel_lsexpr();
static short is_alltbl();
extern void other_select_clauses();
static int table_list();
static int out_tbl_spec();
static int tbl_spec();
static int optional_sel_cls();
static int group_by_clause();
static int grp_list();
extern short agg_spec();
static int aggregate();
static int outer_query_clauses();
static int sort_clause();
static int order_spec();
static int sortby_spec();
extern short is_char();
extern short iskeyword();
extern short get_id();
extern void cp_mv_p();
extern void skip_sp();
extern int end_stmt();
extern void setsubpaths();
static int setaccesspath();
extern void set_obidx();
static void setobidx2();
static int orderbyalts();
static int obaltfact();
static int grpby_in_idx();
static int gfinindex();
static int orderbyidx();
static int obidx2();
static int initordfld();
static int obidxfacts();
static int adjtableord();
static int addordjoinfld();
static int iseqbrack();
static short fldcorrelate();
static int geteqjoin();
static struct _bfactor *unionbterm();
static struct _bfactor *brkinalltrms();
static int factinalltrms();
extern int matchnobrk();
static int obidxcandidate();
static int obidxnextfact();
static int obidxbackfact();
static int rewindordflds();
static int obidxreduceflds();
static int resetordflds();
static int getordbyidx();
static int bldordbyidx();
static int isobindex();
static struct _S_DBHEAD *tmptblalloc();
static struct _S_DBHEAD *tmpfldcreate();
static struct _S_DBINDEX *tmpidxinit();
static int tidxfldcrt();
static struct _S_DBHEAD *wr_fldspecs();
static int tmp4grp_spec();
static int tmp4ob_spec();
static struct _S_DBHEAD *tmp_subqflds();
extern struct _select *fill_temps();
static struct _select *fill_seltmps();
static int tmpbuild();
static struct _select *set_tmpstruct();
static void set_joins();
static int jointblord();
static int gettblidx();
static int joincrit();
static int joincrt2();
static int size_tbls();
static int nxttblbysiz();
static int gettbidx2();
static void idxtosubq();
static int initsubqbrk();
static int reinitindex();
static int equalbrack();
extern int equalexps();
static int equalterms();
static int equalfacts();
static int equalfields();
static int equaldtfuncs();
static int equaldtexps();
static int autocorrelate();
extern void mksubqbfact();
static void tblaccessord();
extern int shortcmp();
extern void typecheck();
extern void chk_select();
static int chk_slist();
extern void cmp_dftoexp();
static struct _expr *expand_tblflds();
extern void fldfmtoffs();
extern void fldlinktbl();
static int expr_type();
static int term_type();
static void fact_type();
static int chk_datexpr();
static void chk_aggreg();
static void mergetype();
static void get_expfld();
static int lkupfield();
static struct _frmtbl *lkupfromtbl();
static int lkup_tfld();
static struct _frmtbl *lkup_ffld();
static int chk_group();
static int grpby_expr();
static int expfld_ingrp();
static int trmfld_ingrp();
static void fctfld_ingrp();
static int dtfld_ingrp();
static void fld_ingrp();
static int uniq_to_grpby();
static void rm_dupe_grpby();
static int chk_having();
static void cond_type();
static void bterm_type();
static void bfact_type();
static int comp_expcast();
static int comp_vlcast();
extern int comp_cast();
extern int time_constant();
static void comp_listv();
static void chkouterjoin();
static void logjoinpair();
static int joinancestor();
static void chk_ordlist();
static int sfld_ordfld();
static int samefield();
static int labl_ordfld();
static void chk_grpidx();
static int reorg_group();
extern void prep_select();
static int selparser();
static int selsqcinit();
extern void initslect();
extern void initfrmtbl();
extern void expression();
static int positive_expression();
static int term();
static void factor();
extern int keyword_var();
extern void todayval();
static int date_func();
static int date_exp();
static void num_date_term();
extern int fact_hostq();
static int field_exp();
extern int fld_spec();
extern int constant();
extern int num_constant();
extern int str_constant();
static char *scan_copy();
extern int digit_seq();
static int add_op();
static int mult_op();
extern char *sqdbuf_alloc();
extern int sqwfmread();
extern int sqwfmwrite();
extern void tablealloc();
static int seltblload();
static int selcondload();
extern void tblunload();
extern int traceinit();
static int traceopen();
extern int traceclose();
extern void dumpstruct();
extern void dumpsqltbl();
extern void dumpsqlfld();
extern void dumphosts();
extern void dumpselect();
extern void dumpselexp();
extern void dumpterm();
extern void dumpfact();
extern void dumpdtexp();
extern void dumpfield();
extern void dumptable();
extern void dumpselflds();
extern void dumpcond();
extern void dumpbfact();
extern void dumpvlist();
extern void dumpoptim();
extern void dumpbrack();
extern void dumpfldlist();
extern void dumpfldnam();
extern void dumpsortfield();
extern void dumpordtbls();
static int dumpordflds();
static int ptrerr();
extern void setdmpphs();
extern void pr_ptr();
extern void dumpdec();
extern void dumpdtime();
extern void dumpdbl();
extern void dumpfxtype();
extern void dumpval();
extern void prp_startlog();
extern int exc_startlog();
extern int prp_beginwk();
extern int prp_commitwk();
extern int prp_rollback();
extern int prp_rfwddb();
extern int exc_rfwddb();
extern int gettransmode();
extern int getnologmode();
extern void prep_unld();
extern int exc_unld();
extern void prep_update();
extern void upd_stmt();
static int upd_spec();
static void set_list();
static void assignment();
static int assig_tuple();
static int field_list();
static int field_id();
static int expr_list();
static int set_subquery();
extern void chk_setflds();
static int cmp_updtype();
extern void updatecurr();
extern void openupdtbl();
extern int readupdtbl();
extern void aftreadahead();
extern void prp_updstat();
extern void exc_updstat();
extern void valstartup();
extern void val_init();
extern void valgetdf();
extern void strvalinit();
extern void dtvalinit();
static char *val_getp();
extern int valputdf();
extern int sqlda_to_val();
extern void val_to_sqlda();
extern void val_cast_sqlda();
extern void setindic();
extern void valformat();
extern void valnull();
extern short valtoshort();
extern long valtolong();
extern float valtoflt();
extern double valtodbl();
extern int valcmp();
extern void valcopy();
extern void valarith();
extern void getmaxval();
extern void getminval();
static void getlimit();
extern int ismaxval();
extern int isminval();
extern void negval();
static int limitcmp();
static struct decimal *getlimdec();
extern int nvalfitfld();
extern int getvvtlen();
extern int dtcvval();
extern void where_clause();
extern void condition();
static int bool_term();
static void bool_factor();
static int is_bool_paren();
static void predicate();
static void cmparison();
extern short invbop();
static short invqop();
static int col1_query_spec();
static int cnstant_list();
static struct _listv *const_list_expr();
static void end_range_const();
static int between_range();
extern int vl_hostq();
static short comp_op();
