
$include sqlca;

$struct HOSTSTRUCT {
  int bookno;
  char agent[20];
  dtime_t  mod_date;
} hoststruct;


/**
$hoststruct  callhost;
**/

$define AGENT_SIZE 20;

$typedef struct defstruct {
  int bookno;
  char agent[AGENT_SIZE+1];
} defstruct;

$defstruct newdefstruct; 

/* $include "test.h"; */

struct sqlda *qdesc;

main()
{
	$int bookno;
	$char agent[5];
        $char stmt[100];

	$database demo;				-- sample comment 1

        goto skipto3;

        $prepare stmt  from "select * from slmaster where bkno = 18201";
	chk_fatal( "PREPARE");
/**
        $prepare stmt  from "select * from slmaster where bkno = 18201";
	chk_fatal( "PREPARE");
**/

        $describe stmt into qdesc;
	chk_fatal( "DESCRIBE");
	$declare curs0 cursor for stmt;
	chk_fatal( "DECLARE");

        sqdbuf_alloc(&_SQ1, qdesc, 1);

	$open curs0;
	chk_fatal( "OPEN");

        $fetch curs0 using descriptor qdesc; 

/**
   {
        int i;
        struct sqlda *psqlda = _SQ1._SQCsqlda;
        struct sqlvar_struct *psqlvar = psqlda->sqlvar;
        int nullflag;
        for (i=0; i < psqlda->sqld; ++i, ++psqlvar) {
             printf("%-20s: (%d, %2d, %s) (%d, %2d, %ld) %d\n", 
                 psqlvar->sqlname, 
                 psqlvar->sqltype,
                 psqlvar->sqllen,
                 psqlvar->sqldata,
                 psqlvar->sqlitype,
                 psqlvar->sqlilen,
                 psqlvar->sqlidata,
                 risnull(psqlvar->sqltype, psqlvar->sqldata)
                 );
            }
   dumpsqlvars(psqlda->sqlvar, psqlda->sqld, (char *)0, 0, 0);

   }
**/

	$close curs0;
	chk_error( "CLOSE");
	$free curs0;
	chk_error( "FREE");

        exit(0);


        $execute immediate "select * from slmaster where bkno = 18201";
	chk_fatal( "EXECUTE IMMEDIATE");

 skipto3:
	$declare curs cursor for
	    select bkno, agent from slmaster
		where bkno = 18201;		-- sample comment 2
	chk_fatal( "DECLARE");

	$open curs;
	chk_fatal( "OPEN");

        callfetch2(&newdefstruct);
        printf("bkno = %d, agent = %s\n",
                newdefstruct.bookno, newdefstruct.agent);

	$close curs;
	chk_error( "CLOSE");
	$free curs;
	chk_error( "FREE");

        $close database;

	exit( 0);
}

callfetch(xcalldefstruct)
$parameter defstruct *xcalldefstruct;
{
	while( 1) {
            $defstruct calldefstruct;
	    $fetch curs into $calldefstruct.bookno, $calldefstruct.agent;
            memcpy(xcalldefstruct, &calldefstruct, sizeof(defstruct));
	    chk_fatal( "FETCH");
	    if (sqlca.sqlcode == SQLNOTFOUND)
		break;
	    printf( "bkno = %d, agent = %s\n", 
                    xcalldefstruct->bookno, xcalldefstruct->agent);
	}
}

callfetch2(calldefstruct)
$parameter defstruct *calldefstruct;
{
	while( 1) {
	    $fetch curs into $calldefstruct->bookno, $calldefstruct->agent;
	    chk_fatal( "FETCH");
	    if (sqlca.sqlcode == SQLNOTFOUND)
		break;
	    printf( "bkno = %d, agent = %s\n", 
                    calldefstruct->bookno, calldefstruct->agent);
	}
}

callfetch3(calldefstruct)
$parameter defstruct *calldefstruct;
{
	while( 1) {
	    $fetch curs into $calldefstruct->bookno, $calldefstruct->agent;
	    chk_fatal( "FETCH");
	    if (sqlca.sqlcode == SQLNOTFOUND)
		break;
	    printf( "bkno = %d, agent = %s\n", 
                    calldefstruct->bookno, calldefstruct->agent);
	}
}

