#if defined()
/* for abstract data types (),
   gcc on linux, and most other compilers, will let us squelch
   those silly warnings if we declare the struct with no memebers.
   It's a kind of "forward" declaration...
*/

struct IsamPath;
struct IsamNode;
struct IsamFree;
struct IsamFile;
struct decacc;
struct AdmDup;
struct _userlist;

#endif

#ifdef DISAM8 
#define ISAMSIGNTYPE       /* define for disam8 */
#else
#define ISAMSIGNTYPE  unsigned  /* define for isam12 */
#endif

extern int dec_round();
extern int decadd();
extern int deccmp();
extern int deccvint();
extern int dectoint();
extern int deccvlong();
extern int dectolong();
static int deccvfix();
static int dectofix();
extern int deccvdbl();
extern int dectodbl();
extern int deccvflt();
extern int dectoflt();
static int deccvreal();
static int dectoreal();
extern int stdecimal();
extern int lddecimal();
static void comp100();
static int round100();
extern int deccvasc();
extern int decdiv();
extern char *dececvt();
extern char *decefcvt();
extern int decchs();
extern int decround();
extern int dectrunc();
extern int isdbdec();
extern char *decfcvt();
extern int decmul();
extern int mod100();
extern int decsub();
extern int dectoasc();
extern int deccopy();
extern int issusplog();
extern int isresumlog();
extern int isvclose();
extern int isLock();
extern int isUnLock();
extern int isRelease();
extern int isRelRec();
extern int isRelCurr();
extern int isThreaded();
extern int isAdmDtoI();
extern struct IsamFile *isAdmItoD();
extern int isCleanUp();
extern int isAdmOpen();
extern int isAdmCheck();
extern int isAdmClose();
extern int isAdmDupData();
extern void isAdmCrit();
extern void isAdmSafe();
extern void isAdmFail();
extern int isAdmDupLock();
extern int isAdmDupDrop();
static int newitem();
static struct IsamFile *getisam();
static int dupopen();
static int dupclose();
/* static int dupcount(); compiler warning */
static int findname();
static int getdatlen();
extern struct IsamFile *isBuild();
extern int isPrecious();
extern int isAddIndex();
extern int isFillIdx();
extern int isCheckData();
extern int isCheckIndex();
extern int isRebuildFree();
extern int isRebuildIdx();
static int datamatch();
extern struct IsamFile *isCluster();
extern struct IsamFile *isClone();
extern int isCopy();
static int mktempname();
extern int isCompKey();
extern int isCompNext();
extern int isCompScan();
extern int isCustLen();
extern int isCustCmp();
static int bytecmp();
static int quadcmp();
static int rfacmp();
extern int isGetData();
extern int isPutData();
extern int isDelCheck();
extern int isDelData();
extern int isDelete();
extern int isDelCurr();
extern int isDelRec();
static int delete();
static int delpure();
extern int isEntry();
extern int isDelta();
extern int isFail();
extern void isFatal();
extern void is_fatal();
extern int isErase();
extern int isRename();
static struct IsamFile *tempopen();
static int tempclose();
extern long isGetFree();
extern int isPutFree();
extern long isFreeCount();
extern int isFreeClear();
extern int isFreeWrite();
extern int isFreeFree();
extern int isFreeDrop();
static int refresh();
extern int isTreeInsert();
static int flatgrow();
static int flatins();
static int compgrow();
static int compins();
static int comphalf();
static int insertpoint();
static int initroot();
static long nextdup();
extern int isUserInfo();
extern int isMakeHead();
extern int isLoadHead();
extern int isHeadWrite();
extern int isHeadKdsc();
extern int isHeadFree();
static int bootstrap();
static void loadflags();
static void saveflags();
extern int isDelIndex();
extern int isWipeIdx();
static int deletepath();
extern int isRefNode();
extern int isUpdNode();
extern int isGetNode();
extern int isPutNode();
extern int isMarkNode();
extern int isLoadIndexes();
extern int isTestIndex();
extern int isFindIndex();
extern int isMakeIndex();
extern int isDropIndex();
extern int isFreeIndex();
static int instpath();
static int initpath();
static int freepath();
extern int isIndexInfo();
extern int isIsamInfo();
extern int isErrno();
extern int isErrio();
extern ISAMSIGNTYPE long isRecnum();
extern long isReclen();
extern int isSetrec();
extern int isSetlen();
static int dictload();
extern int isKeyMake();
extern int isKeyLoad();
extern int isKeyCmp();
extern int isKeyMatch();
extern int isKeyNull();
static int findoff();
static int signcmp();
static int flatcmp();
static int mintcmp();
static int mlongcmp();
static int floatcmp();
static int doublecmp();
extern int isGetLastRec();
extern int isSetLastRec();
extern int isLastRec();
extern int isLocate();
extern int isEdge();
extern int isWalk();
extern int isFind();
extern long isCurrent();
static int indexed();
static int natural();
extern int isLockOpen();
extern int isLockExcl();
extern int isDropExcl();
extern int isDropFile();
extern int isLockRead();
extern int isLockWrite();
extern int isDropLock();
extern int isLocked();
extern int isLockTest();
extern int isLockData();
extern int isDropData();
extern int isLockDall();
extern int isDropDall();
static int findslot();
static long getoff();
static int setlock();
static void droplock();
static void droplist();
static int lockdata();
static void dropdata();
extern char *is_malloc();
extern char *is_realloc();
extern char *is_free();
extern void is_memset();
extern long ldMint();
extern int stMint();
extern int ld_int();
extern int st_int();
extern long ld_long();
extern int st_long();
extern int ldInt();
extern int stInt();
extern long ldLong();
extern int stLong();
extern int stChar();
extern int ldChar();
extern float ldFloat();
extern int stFloat();
extern double ldDbl();
extern int stDbl();
extern int stFltNull();
extern float ldFltNull();
extern int stDblNull();
extern double ldDblNull();
extern struct IsamNode *isMakeNode();
extern int isInitInfo();
extern struct IsamNode *isFreeNode();
extern int isNodeWalk();
extern int isNodeMatch();
extern int isNodeGreat();
static int flatwalk();
static int flatmatch();
static int flatgreat();
static int flatoff();
static int flatval();
static int compwalk();
static int compmatch();
static int compgreat();
static int compval();
extern struct IsamFile *isOpen();
extern int isClose();
extern int isLockCheck();
extern int isSetMode();
extern int isPathIns();
extern int isPathSplit();
extern int isPathAdd();
extern int isPathDown();
extern int isPathClear();
extern int isPathWrite();
extern int isPathFree();
static int pathwrite();
static struct IsamNode *findnode();
static int dropnode();
static int dropnode2();
static int clearbuf();
static int writebuf();
static int freebuf();
extern int isTreeDelete();
static int flatdelete();
static int flatsquash();
static int compdelete();
static int compsquash();
static int quickcheck();
static int searchfind();
static int endcheck();
extern int isRead();
extern int isStart();
extern int isIndex();
extern int isGoto();
extern int isData();
extern int isPush();
extern int isPop();
static int datlock();
static int locrec();
static void readfail();
static void startfail();
extern char *isDbuffer();
extern int isDsquash();
extern int isDexpand();
static int tmpsize();
static int rle();
static int rleHead();
static int rleBody();
static int rld();
extern int is_create();
extern int is_open();
extern int is_close();
extern int is_read();
extern int is_write();
extern unsigned long is_size();
extern unsigned long is_tell();
extern int is_unlink();
extern int is_rename();
extern int is_lock();
extern int is_drop();
extern long is_getpid();
extern long is_getuid();
static int makename();
extern int testlink();
static int storefd();
static int loadfd();
extern int isTreeFirst();
extern int isTreeLast();
extern int isTreeCurr();
extern int isTreePrev();
extern int isTreeNext();
extern int isTreeMatch();
extern int isTreeGreat();
static int walkedge();
static int currmatch();
extern int isSetUnique();
extern int isUniqueId();
extern int isRewrite();
extern int isRewCurr();
extern int isRewRec();
extern int isRewNxt();
static int rewrite();
static int rewpure();
extern int isWrite();
extern int isWrLock();
extern int isWrCurr();
static long insert();
static long inspure();
extern int isbuild();
extern int isvbuild();
extern int isaddindex();
extern int isdelindex();
extern int iscluster();
extern int isclone();
extern int iscopy();
extern int ischeckdata();
extern int ischeckindex();
extern int iserase();
extern int isrename();
extern int isflush();
extern int issetunique();
extern int isuniqueid();
extern int isprecious();
extern int islockcheck();
extern char *isseekey();
extern void isfatal();
extern int isthreaded();
extern int isindexinfo();
extern int isisaminfo();
extern int isuserinfo();
extern char *isdi_name();
extern int isdi_datlen();
extern int isdi_curidx();
extern int isdi_idxfd();
extern int isdi_datfd();
extern struct keydesc *isdi_kdsc();
extern int islastrec();
extern int isgetlastrec();
extern int issetlastrec();
extern int islock();
extern int isunlock();
extern int isrelease();
extern int isrelrec();
extern int isrelcurr();
extern int ldint();
extern int stint();
extern long ldlong();
extern int stlong();
extern int stchar();
extern int ldchar();
extern float ldfloat();
extern int stfloat();
extern double lddbl();
extern int stdbl();
extern int stfltnull();
extern float ldfltnull();
extern int stdblnull();
extern double lddblnull();
extern int isopen();
extern int isgetmode();
extern int issetmode();
extern int isclose();
extern int iscleanup();
extern int isstart();
extern int isread();
extern int isindex();
extern int isgoto();
extern int ispush();
extern int ispop();
extern int isdata();
extern ISAMSIGNTYPE long *is_recnum();
extern int *is_reclen();
extern int *is_errno();
extern int *is_errio();
extern int isfilter();
static int rdfilter();
extern int isWrapFind();
extern struct IsamFile *isWrapInit();
extern int isWrapDone();
extern int isWrapRet();
extern int iswrite();
extern int iswrlock();
extern int iswrcurr();
extern int isrewrite();
extern int isrewrec();
extern int isrewcurr();
extern int isrewnxt();
extern int isdelete();
extern int isdelrec();
extern int isdelcurr();
extern ISAMSIGNTYPE long isgetmask();
extern int issetmask();
