#if defined()
/* for abstract data types (),
   gcc on linux, and most other compilers, will let us squelch
   those silly warnings if we declare the struct with no memebers.
   It's a kind of "forward" declaration...
*/

struct _S_RWFILE;
struct dtime;

#endif

extern short fx_to_sqltyp();
extern short sqlda_to_ctyp();
extern short sqlda_to_fxtyp();
extern int dtcvasc();
extern int dttoasc();
extern int dtcmp();
extern char *dtqualname();
extern long daysinyrs();
extern void initsqlca();
extern void ph1err();
extern void ph1errmsg();
extern void errsqlca();
extern void errmsgsqlca();
extern void warn_err();
extern void set_sqlcode();
extern int fright();
extern void fleft();
extern int rdatestr();
extern char *getdbdate();
extern int rdayofweek();
extern int rdefmtdate();
static int getdatetype();
extern void sqlnameshift();
extern void downshift();
extern int rfmtdate();
extern int rfmtlong();
extern int rfmtdec();
extern int rfmtdouble();
static void sethipos();
static void overflow();
extern int msgopen();
extern void msgclose();
extern char *loadmsg();
extern int rgetmsg();
extern int rgetlmsg();
static char *getarg();
extern int risnull();
extern int isbufnull();
extern int sqisnull();
extern int rjulmdy();
extern int rleapyear();
extern int rmdyjul();
extern void rsetnull();
extern int dfsetnull();
extern void sqsetnull();
extern void sqsetzero();
extern int rstrdate();
extern int idatebytyp();
static int dateorder();
extern void rtoday();
extern void sysdate();
extern int rtypalign();
extern int rtypmsize();
extern int rtypwidth();
extern void rupshift();
extern int defmtdbdate();
extern int fmopen();
static int fmclosold();
extern int fmclose();
extern int fmclos2();
extern int fmfind();
extern int fmread();
static int fmisread();
extern int fmrwread();
extern int fmwrite();
extern int fmrewcurr();
extern int fmrewrec();
extern int fmdelcurr();
extern int fmstart();
extern int fmdictinfo();
extern int fmindexinfo();
extern int fmbuild();
extern void sqbuildall();
extern int fmerase();
extern int fmrename();
extern int fmlock();
extern int fmunlock();
extern int fmaddindex();
extern int fmdelindex();
extern int fmuniqueid();
extern int fmsetunique();
extern void fmsetserial();
extern void fmcurclr();
extern void fmcurset();
extern void fmisaminit();
extern int fmrwopen();
extern int fmrwclose();
extern int fmcluster();
static void fmsetview();
static int sqsetstruct();
extern int fmisintrp();
extern int bldkeydesc();
extern int fmstructview();
extern void fmtdouble();
extern double dblround();
extern int buftostr();
extern int fcomma();
extern struct _S_DBHEAD *getdhp();
extern struct _S_DBHEAD *getdhpath();
extern struct _S_DBFIELD *getdfp();
extern struct _S_DBINDEX *getdip();
extern struct _S_DBFIELD *getdidfp();
static int geterr();
extern void errorlevel();
extern int whaterrlvl();
extern char *getdfbuf();
extern int getpdhn();
extern int getpdfn();
extern void getdf();
extern void getdfs();
extern int putdf();
extern void putdfs();
extern char *bufalloc();
extern int mktblpath();
extern int mkpath();
extern void dclrrec();
extern void dclrrng();
extern void rmovchar();
extern void wmovchar();
extern void movnum();
extern void movbin();
extern void rdshort();
extern int wdshort();
extern void rdlong();
extern int wdlong();
extern void rddbl();
extern int wddbl();
extern void rdfloat();
extern int wdfloat();
extern void rddtime();
extern int wddtime();
extern void rddec();
extern int rddecdbl();
extern int wddec();
extern int wddecdbl();
extern int rdmoney();
extern int wdmoney();
extern void prsqldb();
extern void prhdhead();
extern void prdbhead();
extern void prdbfield();
extern void prdbindex();
extern void prdbrec();
extern void prfld();
extern void prdhbuf();
extern void prkeydesc();
extern void prdictinfo();
extern void prjmpenv();
extern int rwopen();
extern int rwputlist();
extern int rwclose();
extern long rwtell();
extern long rwseek();
extern char *rwgets();
extern int rwgetc();
extern int rwread();
extern int rwputs();
extern int rwwrite();
extern long rwincreccnt();
static int rwchkfilenum();
extern int backseek();
static void dump_rwfile();
extern short sq_ldshort();
extern int sq_stshort();
extern int sq_ldint();
extern int sq_stint();
extern long sq_ldlong();
extern int sq_stlong();
extern int sq_stchar();
extern float sq_ldfloat();
extern int sq_stfloat();
extern double sq_lddbl();
extern int sq_stdbl();
extern int fxmemcmp();
extern int sqstrcmp();
extern int nocasecmp();
extern char *strtrim();
extern char *sqstrfind();
extern void fxltoa();
static int reverse();
extern void strcenter();
extern void swapbuf();
extern int creatargs();
extern void load_syscat();
extern void sysopen();
extern void sysstruct();
extern void sysclose();
extern void sysunlock();
extern struct _S_DBHEAD *fmtable();
static int fmfld();
extern int findstbl();
extern int findsidx();
extern int findscol();
extern void prstbl();
extern void prscol();
extern void prsidx();
extern struct _S_DBHEAD *dfinsert();
extern void dfdelete();
extern void dfmodify();
static int tbupdptr();
extern void fmunload();
extern void dhfree();
extern void tmperase();
extern struct _S_DBHEAD *tballoc();
static struct _S_DBHEAD *tbrealloc();
extern void tbfree();
extern int tbbufalloc();
extern void tbbuffree();
static int putdhsize();
static int getdhsize();
extern void inithead();
static int initfield();
extern void initindex();
extern int rtimestr();
extern int rstrtime();
extern int inittmplist();
extern int addtmptbl();
extern void mksqtmpnm();
extern int issqtmpnm();
extern struct _S_DBHEAD *gettmphead();
extern struct _S_DBHEAD *copydh();
extern int istmptbl();
extern int gettmparri();
extern void addtmpidx();
extern int deltmpidx();
extern int istmpidx();
extern void deltmptbl();
extern void prtmptbls();
extern int trxstartlog();
extern int trxlogopen();
extern int trxlogclose();
extern int trxlogname();
extern int trxbeginwrk();
extern int ansibegwrk();
extern int trxcommitwrk();
extern void trxrollback();
extern int trxrllbck_failok();
extern int trxrfwddb();
extern void vtsetnull();
extern int sqiszero();
extern int getvwsize();
extern int getpcksiz();
extern int getvtlen();
extern int getftype();
extern int iswholenum();
extern char *strcompress();
static char *strscan();
