#if defined(LINUX) || defined(INTERIX) || defined(CYGWIN) || defined(SCOUNX) || defined(SUNSOLARIS)
/* for abstract data types (struct that we use only as pointers),
   gcc on linux, and most other compilers, will let us squelch
   those silly warnings if we declare the struct with no memebers.
   It's a kind of "forward" declaration...
*/

struct _S_DTFUNC; 
struct _S_FACTOR; 
struct _S_LIMITS; 
struct _S_SELINDEX; 
struct _S_SFIELD; 
struct _S_SQCURSOR; 
struct _S_SQSTMT; 
struct _S_TBLORD; 
struct _S_VALUE; 
struct _alloclist; 
struct _bfactor; 
struct _bracket; 
struct _dtexpr; 
struct _expr; 
struct _fldlist; 
struct _frmtbl; 
struct _hosthdr; 
struct _joinlst; 
struct _listv; 
struct _optiminfo; 
struct _ordfld; 
struct _select; 
struct _selflds; 
struct _sqlfield; 
struct _sqltbl; 
struct _structmap; 
struct _term; 
struct dtime; 
struct sqlda; 
struct sqlvar_struct; 

#endif

extern void __cdecl prep_alter(struct _S_SQCURSOR *sqc);
static void __cdecl prp_tblalter(struct _S_SQCURSOR *sqc);
static struct _S_DBHEAD *__cdecl prp_aladd(struct _S_SQCURSOR *sqc,struct _S_DBHEAD *pdbhead,long *pserialno);
static int __cdecl prp_aldrop(struct _S_SQCURSOR *sqc,struct _S_DBHEAD *pdbhead);
static int __cdecl prp_almodify(struct _S_SQCURSOR *sqc,struct _S_DBHEAD *pdbhead,long *pserialno);
extern void __cdecl exc_tblalter(struct _S_SQCURSOR *sqc);
static int __cdecl _l_rewrite(struct _S_DBHEAD *poldhead,struct _S_DBHEAD *pnewhead,long serialno,long oldtabid);
static int __cdecl modcolauth(long tabid,short oldcolno,short newcolno);
static int __cdecl sysrewrite(struct _S_DBHEAD *pdbhead,char *owner);
static void __cdecl fxconvert(char *srcbuf,int srctype,int srclen,char *desbuf,int destype,int deslen);
static int __cdecl dffldtodbl(char *fldbuf,int fldtype,int fldlen,double *pdvalue);
static int __cdecl dfdbltofld(double dvalue,char *fldbuf,int fldtype,int fldlen);
static void __cdecl fldtodbl(char *fldbuf,int fldtype,int fldlen,double *pdvalue);
static void __cdecl dbltofld(double dvalue,char *fldbuf,int fldtype,int fldlen);
extern void __cdecl prp_idxalter(struct _S_SQCURSOR *sqc);
extern void __cdecl exc_idxalter(struct _S_SQCURSOR *sqc);
extern void __cdecl prep_create(struct _S_SQCURSOR *sqc);
static int __cdecl prp_crdbase(struct _S_SQCURSOR *sqc);
extern char *__cdecl getlogname(struct _S_SQCURSOR *sqc);
extern void __cdecl exc_crdbase(struct _S_SQCURSOR *sqc);
static int __cdecl bldsystbl(struct _S_DBHEAD *pdbhead);
static void __cdecl fail_crdb(int eno);
static void __cdecl prp_crtable(struct _S_SQCURSOR *sqc,short stmttype);
static int __cdecl getcoldef(struct _S_SQCURSOR *sqc,char *colname,int *pcoltype,int *pcollength,int *pcoldec,long *pserialno,int *pcolflag);
extern void __cdecl exc_crtable(struct _S_SQCURSOR *sqc);
static void __cdecl prp_crindex(struct _S_SQCURSOR *sqc,char idxtype);
extern void __cdecl exc_crindex(struct _S_SQCURSOR *sqc);
extern void __cdecl exc_crsysidx(struct _S_DBINDEX *newdbindex,char *tblowner,char *idxowner);
extern void __cdecl exc_crtmpidx(struct _S_DBINDEX *newdbindex);
static int __cdecl syscreate(struct _S_DBHEAD *pdbhead,char *owner,short modeansi);
static int __cdecl syssetcnt(struct _S_DBHEAD *pdbhead);
extern void __cdecl upd_nrow(char *tablename,int increment);
extern int __cdecl pnet_string(char *str,int n);
extern char *__cdecl gnet_string(char *func,char *what,int *retval);
extern int __cdecl pnet_short(short n);
extern int __cdecl gnet_short(short *n);
extern int __cdecl pnet_long(long n);
extern int __cdecl gnet_long(long *n);
extern int __cdecl pnet_float(float n);
extern int __cdecl gnet_float(float *n);
extern int __cdecl pnet_double(double n);
extern int __cdecl gnet_double(double *n);
extern int __cdecl pnet_dec(struct decimal *dec);
extern int __cdecl gnet_dec(struct decimal *dec);
extern int __cdecl pnet_dtime(struct dtime *dtm);
extern int __cdecl gnet_dtime(struct dtime *dtm);
extern int __cdecl pnet_bool(int ibool);
extern int __cdecl gnet_bool(int *ibool);
extern int __cdecl pnet_qdesc(struct sqlda *qdesc,short putdata);
extern int __cdecl gnet_qdesc(struct sqlda **q_desc ,short getdata);
extern int __cdecl pnet_bind(short nbind,struct sqlvar_struct *sqbind,short putdata,short putname);
extern int __cdecl gnet_bind(short *nbind,struct sqlvar_struct **sqbind ,short getdata,short getname);
extern int __cdecl pnet_qdvar(char *vdata,short vtype,short vlen,short putdata);
extern int __cdecl gnet_qdvar(char **vdata ,short *vtype,short *vlen,short getdata,char *what);
extern int __cdecl pnet_qddata(short nbind,struct sqlvar_struct *sqbind);
extern int __cdecl gnet_qddata(short nbind,struct sqlvar_struct *sqbind);
extern int __cdecl pnet_data(char *data,short dtype,short dlen);
extern int __cdecl gnet_data(char *data,short dtype,short dlen);
extern int __cdecl pnet_sqlca(void);
extern int __cdecl gnet_sqlca(void);
extern int __cdecl pnet_cmdtxt(char **sqlcmdtxt );
extern char **__cdecl gnet_cmdtxt(char *func,int *retval) ;
extern void __cdecl free_bind(short nbind,struct sqlvar_struct *sqbind,short freedata);
extern void __cdecl free_qdesc(struct sqlda *qdesc,short freedata);
extern void __cdecl free_cmdtxt(char **sqlcmdtxt );
static int __cdecl net_read(char *buf,int *n);
static int __cdecl net_write(char *buf,int *n);
extern int __cdecl net_flush(void);
static int __cdecl initcursmap(void);
extern struct _S_SQCURSOR *__cdecl init_svsqc(long cltptr);
extern struct _S_SQCURSOR *__cdecl get_svsqc(long cltptr);
extern void __cdecl put_svbind(long cltptr,short nibind,struct sqlvar_struct *sqibind,short nobind,struct sqlvar_struct *sqobind);
extern void __cdecl put_svibind(long cltptr,short nibind,struct sqlvar_struct *sqibind);
extern void __cdecl put_svobind(long cltptr,short nobind,struct sqlvar_struct *sqobind);
extern int __cdecl get_svbind(long cltptr,short *nibind,struct sqlvar_struct **sqibind ,short *nobind,struct sqlvar_struct **sqobind );
extern void __cdecl free_svbind(long cltptr);
extern void __cdecl prep_dbase(struct _S_SQCURSOR *sqc);
extern void __cdecl getdbdir(struct _S_SQCURSOR *sqc,char *stmt);
extern void __cdecl mkdbpath(char *dbname,char *dbdir,short create);
extern int __cdecl fxdatadb(void);
extern int __cdecl exec_dbase(struct _S_SQCURSOR *sqc,short dbareq);
extern void __cdecl dbinit(void);
extern void __cdecl dbfrompath(char *dbdir,char *dbname);
extern int __cdecl is_hostdb(struct _S_SQCURSOR *sqc,char *stmttype,char *func);
extern int __cdecl prep_closedb(struct _S_SQCURSOR *sqc);
extern void __cdecl exec_closedb(void);
extern void __cdecl prep_delete(struct _S_SQCURSOR *sqc);
extern void __cdecl del_stmt(struct _S_SQCURSOR *sqc);
static int __cdecl del_from(struct _S_SQCURSOR *sqc);
extern void __cdecl del_row(struct _select *sel);
extern struct _cond *__cdecl chknest_cond(struct _S_SQCURSOR *sqc,struct _cond *ocond);
static struct _cond *__cdecl dist_bool(struct _S_SQCURSOR *sqc,struct _cond *bcond,int numterms);
static struct _bterm *__cdecl link_fact(struct _S_SQCURSOR *sqc,struct _bfactor *fact,struct _cond *fcond,struct _bterm *trm);
static struct _cond *__cdecl dist_not(struct _S_SQCURSOR *sqc,struct _cond *bcond);
extern void __cdecl initfacts(struct _cond *cond,short nullhostbrk);
extern void __cdecl prep_drop(struct _S_SQCURSOR *sqc);
static void __cdecl prp_drdbase(struct _S_SQCURSOR *sqc);
extern void __cdecl exc_drdbase(struct _S_SQCURSOR *sqc);
extern void __cdecl rm_dir_files(char *dir);
extern int __cdecl is_dbfile(char *fname);
static int __cdecl prp_drtable(struct _S_SQCURSOR *sqc);
extern void __cdecl exc_drtable(struct _S_SQCURSOR *sqc);
extern void __cdecl delauthrecs(struct _S_DBHEAD *tp,long tabid);
static int __cdecl prp_drindex(struct _S_SQCURSOR *sqc);
extern void __cdecl exc_drindex(struct _S_SQCURSOR *sqc);
extern int __cdecl ecpp_stmt(struct _S_SQCURSOR *sqc);
extern int __cdecl ecpp_db(struct _S_SQCURSOR *sqc);
extern int __cdecl ecpp_dclose(struct _S_SQCURSOR *sqc);
extern int __cdecl ecpp_close(struct _S_SQCURSOR *sqc);
extern int __cdecl ecpp_beginwk(struct _S_SQCURSOR *sqc);
extern int __cdecl ecpp_commitwk(struct _S_SQCURSOR *sqc);
extern int __cdecl ecpp_rollback(struct _S_SQCURSOR *sqc);
extern int __cdecl pr_stmnt(struct _S_SQCURSOR *sqc);
extern int __cdecl pp1_stmnt(struct _S_SQCURSOR *sqc,short indecl,char *stmtp);
extern int __cdecl pp2_stmnt(struct _S_SQCURSOR *sqc,short indecl);
extern int __cdecl prstmtpart(struct _S_SQCURSOR *sqc,char *endp);
extern int __cdecl sel_into(struct _S_SQCURSOR *sqc,char *intop);
extern int __cdecl ppgetcurs(struct _S_SQCURSOR *sqc,char *cursname);
extern int __cdecl ecpp_hostv(struct _S_SQCURSOR *sqc,short inbind,short multiok,short prq);
static int __cdecl do_erase(struct _S_SQCURSOR *sqc);
extern int __cdecl _iqdatabase(char *dbname,short exclus,int nibind,struct sqlvar_struct *sqibind);
extern void __cdecl _iqdbclose(void);
extern int __cdecl _iqstmnt(struct _S_SQSTMT *sqs,char **sqlcmdtxt ,int nibind,struct sqlvar_struct *sqibind,char *str2);
extern int __cdecl _iqxecute(struct _S_SQCURSOR *sqc,int nibind,struct sqlvar_struct *sqibind,struct sqlda *q_desc,char *char1);
extern int __cdecl _iqeximm(char *sqlcmdbuf);
extern struct _hostv *__cdecl init_host(struct _S_SQCURSOR *sqc);
static int __cdecl bindhosts(struct _S_SQCURSOR *sqc,short nibind,struct sqlvar_struct *sqibind,struct sqlda *q_desc);
static void __cdecl obind_alloc(struct _S_SQCURSOR *sqc,int nobind,struct sqlvar_struct *sqobind);
extern int __cdecl _iqslct(struct _S_SQCURSOR *sqc,char **sqlcmdtxt ,int nibind,struct sqlvar_struct *sqibind,int nobind,struct sqlvar_struct *sqobind,int int2);
extern int __cdecl _iqprepare(struct _S_SQCURSOR *sqc,char *sqlcmdbuf);
extern struct sqlda *__cdecl init_sel_sqlda(struct _S_SQCURSOR *sqc,struct _expr *selexp);
static int __cdecl _iqprp2(struct _S_SQCURSOR *sqc,char **sqlcmdtxt );
extern int __cdecl _iqdscribe(struct _S_SQCURSOR *sqc,struct sqlda **q_desc );
extern char *__cdecl get_fhdr(struct _expr *ep);
extern int __cdecl _iqdclcur(struct _S_SQCURSOR *sqc,char *cursname,char **sqlcmdtxt ,short nibind,struct sqlvar_struct *sqibind,short nobind,struct sqlvar_struct *sqobind,int cursstat);
extern int __cdecl _iqddclcur(struct _S_SQCURSOR *sqc,char *cursname,int cursstat);
static int __cdecl chk_decl(struct _S_SQCURSOR *sqc);
extern int __cdecl _iqcopen(struct _S_SQCURSOR *sqc,short nibind,struct sqlvar_struct *sqibind,struct sqlda *q_desc,char *str3,int int2);
static void __cdecl _iqcop2(struct _S_SQCURSOR *sqc);
extern short __cdecl ctyp_to_sqltyp(short ctype);
extern int __cdecl _iqnftch(struct _S_SQCURSOR *sqc,int nobind,struct sqlvar_struct *sqobind,struct sqlda *q_desc,int ftmode,long rowno,int nibind,struct sqlvar_struct *sqibind,char *str3,int int3);
static long __cdecl sqlda_tolng(struct sqlvar_struct *qvar);
extern int __cdecl _iqinsput(struct _S_SQCURSOR *sqc,int nibind,struct sqlvar_struct *sqibind,struct sqlda *q_desc,char *str1);
extern int __cdecl _iqclose(struct _S_SQCURSOR *sqc);
extern int __cdecl _iqclos2(struct _S_SQCURSOR *sqc);
static int __cdecl closeseltbls(struct _select *sel, int reopen);
static struct _select *__cdecl sel_refresh(struct _S_SQCURSOR *sqc,struct _select *sel,short nullqdesc);
extern int __cdecl _iqfree(struct _S_SQCURSOR *sqc);
static int __cdecl _iqfre2(struct _S_SQCURSOR *sqc);
static int __cdecl cmd_alloc(struct _S_SQCURSOR *sqc,char **sqlcmdtxt );
static int __cdecl cmd_free(struct _S_SQCURSOR *sqc);
static int __cdecl memp_alloc(struct _S_SQCURSOR *sqc);
static int __cdecl memp_free(struct _S_SQCURSOR *sqc);
extern void __cdecl pp_free(struct _S_SQCURSOR *sqc);
static int __cdecl sqc_check(struct _S_SQCURSOR *sqc);
static struct _select *__cdecl sel_sqcchk(struct _S_SQCURSOR *sqc);
static int __cdecl initjmpenv(void);
extern void __cdecl ph2err(struct _S_SQCURSOR *sqc,char *textp,int eno);
extern void __cdecl ph2errmsg(struct _S_SQCURSOR *sqc,char *textp,char *msg,int eno);
extern int __cdecl cl_database(char *dbname,short exclus,int nibind,struct sqlvar_struct *sqibind);
extern int __cdecl cl_dbclose(void);
extern int __cdecl cl_stmnt(struct _S_SQSTMT *sqs,char **sqlcmdtxt ,int nibind,struct sqlvar_struct *sqibind,char *str2);
extern int __cdecl cl_xecute(struct _S_SQCURSOR *sqc,int nibind,struct sqlvar_struct *sqibind,struct sqlda *q_desc,char *char1);
extern int __cdecl cl_eximm(char *sqlcmdbuf);
extern int __cdecl cl_slct(struct _S_SQCURSOR *sqc,char **sqlcmdtxt ,int nibind,struct sqlvar_struct *sqibind,int nobind,struct sqlvar_struct *sqobind,int int2);
extern int __cdecl cl_prepare(struct _S_SQCURSOR *sqc,char *sqlcmdbuf);
extern int __cdecl cl_dscribe(struct _S_SQCURSOR *sqc,struct sqlda **q_desc );
extern int __cdecl cl_dclcur(struct _S_SQCURSOR *sqc,char *cursname,char **sqlcmdtxt ,short nibind,struct sqlvar_struct *sqibind,short nobind,struct sqlvar_struct *sqobind,int cursstat);
extern int __cdecl cl_ddclcur(struct _S_SQCURSOR *sqc,char *cursname,int cursstat);
extern int __cdecl cl_copen(struct _S_SQCURSOR *sqc,short nibind,struct sqlvar_struct *sqibind,struct sqlda *q_desc,char *str3,int int2);
extern int __cdecl cl_nftch(struct _S_SQCURSOR *sqc,int nobind,struct sqlvar_struct *sqobind,struct sqlda *q_desc,int ftmode,long rowno,int nibind,struct sqlvar_struct *sqibind,char *str3,int int3);
extern int __cdecl cl_insput(struct _S_SQCURSOR *sqc,int nibind,struct sqlvar_struct *sqibind,struct sqlda *q_desc,char *str1);
extern int __cdecl cl_close(struct _S_SQCURSOR *sqc);
extern int __cdecl cl_free(struct _S_SQCURSOR *sqc);
extern int __cdecl sqlstart(char *svcname);
extern int __cdecl sqlexit(void);
extern int __cdecl is_cltsrv(void);
extern unsigned __int64 __stdcall Int64ShllMod32(unsigned __int64 Value,unsigned long ShiftCount);
extern __int64 __stdcall Int64ShraMod32(__int64 Value,unsigned long ShiftCount);
extern unsigned __int64 __stdcall Int64ShrlMod32(unsigned __int64 Value,unsigned long ShiftCount);
extern void *__cdecl GetFiberData(void );
extern void *__cdecl GetCurrentFiber(void );
extern int __cdecl sv_database(void);
extern int __cdecl sv_dbclose(void);
extern int __cdecl sv_stmnt(void);
extern int __cdecl sv_xecute(void);
extern int __cdecl sv_slct(void);
extern int __cdecl sv_prepare(void);
extern int __cdecl sv_dscribe(void);
extern int __cdecl sv_dclcur(void);
extern int __cdecl sv_ddclcur(void);
extern int __cdecl sv_copen(void);
extern int __cdecl sv_nftch(void);
extern int __cdecl sv_insput(void);
extern int __cdecl sv_close(void);
extern int __cdecl sv_free(void);
extern void __cdecl prep_explain(struct _S_SQCURSOR *sqc);
extern void __cdecl exec_explain(struct _S_SQCURSOR *sqc);
extern void __cdecl expl_stmt(struct _S_SQCURSOR *sqc);
extern void __cdecl expl_select(struct _select *sel,int indent);
extern void __cdecl expl_table(struct _frmtbl *ftp,struct _S_FACTOR *aggfct,int indent);
extern void __cdecl expl_temps(struct _select *sel);
extern void __cdecl expl_bracks(struct _S_SFIELD *fld,struct _bracket *brk,short *line1,int indent);
static int __cdecl expl_union(struct _S_SFIELD *fld,short *line1,int indent);
static int __cdecl expl_bfact(struct _bfactor *bfact,short *line1,int indent);
static int __cdecl expl_exp(struct _expr *ep);
static int __cdecl expl_term(struct _term *trm);
static int __cdecl expl_fact(struct _S_FACTOR *fact);
static void __cdecl expl_aggreg(struct _S_FACTOR *fact);
static int __cdecl expl_fld(struct _S_SFIELD *fld);
static int __cdecl expl_fname(struct _S_SFIELD *fld);
static int __cdecl expl_dtexp(struct _dtexpr *dtep);
static int __cdecl expl_vlst(struct _listv *vl);
extern void __cdecl expl_val(struct _S_VALUE *val);
static int __cdecl expl_subq(struct _select *sel,int indent);
static int __cdecl prindent(int indent);
extern void __cdecl expl_bop(short bop);
extern void __cdecl expl_ismode(int mode);
extern void __cdecl expl_text(char *s);
extern int __cdecl expl_fileno(void);
static int __cdecl equalbfacts(struct _bfactor *bfct1,struct _bfactor *bfct2);
extern char *__cdecl getsqstmt(char *cfs,int caller);
extern struct _S_DBINDEX *__cdecl xfindindex(struct _S_DBFIELD **flds ,short *sortord);
extern int __cdecl comp_type(short typ1,short dtqual1,short typ2,short dtqual2);
extern int __cdecl datafitfld(short dtype,short dsize,short dprec,short ddecs,short dqual,struct _S_DBFIELD *fp);
static int __cdecl getmagnitude(short type,short *mag);
static int __cdecl getdecsize(short type,short *decs);
extern void __cdecl prepsql(struct _S_SQCURSOR *sqc);
extern void __cdecl execsql(struct _S_SQCURSOR *sqc);
static int __cdecl prep_set(struct _S_SQCURSOR *sqc);
extern void __cdecl getcoltype(struct _S_SQCURSOR *sqc,char *colname,int *pcoltype,int *pcollength,int *pcoldec,long *pserialno,int *pcolflag);
extern short __cdecl getdtqual(struct _S_SQCURSOR *sqc);
static int __cdecl dtqualifier(struct _S_SQCURSOR *sqc);
extern void __cdecl getdbname(struct _S_SQCURSOR *sqc,char *dbname,char *dbstmt);
extern short __cdecl get_dbpath(struct _S_SQCURSOR *sqc);
extern void __cdecl gettblname(struct _S_SQCURSOR *sqc,char *tname,char *owner);
extern void __cdecl getidxname(struct _S_SQCURSOR *sqc,char *indexname,char *owner);
extern short __cdecl getownedobj(struct _S_SQCURSOR *sqc,char *owner,short ownerlen,short *ownerqt);
extern void __cdecl chkownedobjerr(short status,char *obj,short objlen);
extern void __cdecl getcolname(struct _S_SQCURSOR *sqc,char *colname);
extern void __cdecl fld_list(struct _S_SQCURSOR *sqc,struct _sqlfield *sqfp);
extern void __cdecl setstbl(struct _S_DBHEAD *pdbhead,long tabid,char *owner);
extern void __cdecl setscol(struct _S_DBFIELD *pdbfield,long tabid,int colno);
extern void __cdecl setsidx(struct _S_DBINDEX *pdbindex,long tabid,char *owner);
extern char *__cdecl mkdskname(char *outname,char *inname,long tabid);
extern void __cdecl chk_intrp(void);
extern void __cdecl prdatawarn(int eno,struct _S_DBFIELD *fp);
extern void __cdecl warnprompt(void);
extern char *__cdecl sqlalloc(struct _S_SQCURSOR *sqc,short siz,char *func,char *what);
static char *__cdecl sqlallc2(struct _alloclist **sqlmem ,char type,short siz,char *func,char *what);
extern void __cdecl parsefree(struct _S_SQCURSOR *sqc);
extern void __cdecl cursfree(struct _S_SQCURSOR *sqc);
static void __cdecl dynaoptfree(struct _select *sel);
static int __cdecl sqlfree(struct _alloclist **sqlmem ,char type);
extern void __cdecl testmem(int mode);
extern void __cdecl do_info(struct _S_SQCURSOR *sqc);
static void __cdecl do_intables(struct _S_SQCURSOR *sqc);
extern void __cdecl do_inindexes(struct _S_SQCURSOR *sqc);
extern void __cdecl do_incolumns(struct _S_SQCURSOR *sqc);
extern void __cdecl prep_insert(struct _S_SQCURSOR *sqc);
extern void __cdecl ins_stmt(struct _S_SQCURSOR *sqc);
static int __cdecl val_list(struct _S_SQCURSOR *sqc);
extern struct sqlda *__cdecl init_ins_sqlda(struct _S_SQCURSOR *sqc);
static int __cdecl getinsval(struct _S_SQCURSOR *sqc,struct _sqlfield *modf);
extern void __cdecl chk_insert(struct _S_SQCURSOR *sqc);
static void __cdecl chk_insval(struct _S_SQCURSOR *sqc,struct _sqlfield *modf);
extern void __cdecl exec_insert(struct _S_SQCURSOR *sqc);
extern void __cdecl put_insert(struct _S_SQCURSOR *sqc);
extern void __cdecl open_instbl(struct _sqltbl *ins);
extern void __cdecl setinssqlca(struct _S_DBHEAD *tp);
extern void __cdecl load_insert(struct _S_SQCURSOR *sqc,char *cfs,struct _S_DBHEAD *tp);
extern void __cdecl insserial(struct _S_DBHEAD *tp);
static int __cdecl fmterr(struct _S_SQCURSOR *sqc,char *type,int fldnum,int linenum);
static int __cdecl ldinserr(struct _S_SQCURSOR *sqc,int eno);
extern void __cdecl prep_ld(struct _S_SQCURSOR *sqc);
extern void __cdecl exec_ld(struct _S_SQCURSOR *sqc);
extern void __cdecl prp_setlckmd(struct _S_SQCURSOR *sqc);
extern void __cdecl exc_setlckmd(struct _S_SQCURSOR *sqc);
extern void __cdecl prep_lock(struct _S_SQCURSOR *sqc);
extern void __cdecl exec_lock(struct _S_SQCURSOR *sqc);
extern void __cdecl prep_unlock(struct _S_SQCURSOR *sqc);
extern void __cdecl exec_unlock(struct _S_SQCURSOR *sqc);
extern int __cdecl dopermute(int n,int (__cdecl *recvfunc)(char *,int ));
extern int __cdecl docombo(int n,int (__cdecl *recvfunc)(char *,int ));
static int __cdecl getpermute(int n,int (__cdecl *recvfunc)(char *,int ),int doperm);
static int __cdecl combo(char *s1,int len1,char *s2,int len2,int n,int (__cdecl *recvfunc)(char *,int ),int doperm);
static int __cdecl permute(char *is,int n,int offset,int (__cdecl *recvfunc)(char *,int ));
extern void __cdecl dumpstmtid(int fd,char *label,short stmt,int indent);
extern void __cdecl dumpexptyp(int fd,char *label,short etype,int indent);
extern void __cdecl dumpdattyp(int fd,char *label,short dtype,int indent);
extern void __cdecl dumpaggreg(int fd,char *label,short agg,int indent);
extern void __cdecl dumpboolop(int fd,char *label,short bop,int indent);
extern void __cdecl dumpsubqop(int fd,char *label,short qop,int indent);
extern void __cdecl dumpistype(int fd,char *label,short sqltyp,int indent);
extern void __cdecl dumpdef(int fd,char *name,char **arr ,short val,int indent);
extern void __cdecl dumpbuf(int fd,int indent);
extern void __cdecl prep_grant(struct _S_SQCURSOR *sqc);
extern void __cdecl prep_revoke(struct _S_SQCURSOR *sqc);
static short __cdecl getprivilege(struct _S_SQCURSOR *sqc);
static void __cdecl user_list(struct _S_SQCURSOR *sqc,struct _userlist *ul);
static void __cdecl user_name(struct _S_SQCURSOR *sqc,char *user);
extern void __cdecl exec_grant(struct _S_SQCURSOR *sqc);
static void __cdecl grant_tabpriv(struct _S_SQCURSOR *sqc);
static int __cdecl withgrantpriv(char *user,long tabid,int colno,short priv,struct _S_DBHEAD *tp,struct _sqltbl *tbl);
extern void __cdecl exec_revoke(struct _S_SQCURSOR *sqc);
static void __cdecl revk_tabpriv(struct _S_SQCURSOR *sqc,char *revoker);
static int __cdecl revk_fldpriv(long tabid,short priv,char *user);
static void __cdecl upd_dbpriv(struct _S_SQCURSOR *sqc,char *action);
static void __cdecl privwrite(struct _S_DBHEAD *tp,int recstat);
extern void __cdecl getuserpriv(void);
extern long __cdecl chk_tabpriv(long tabid,short priv);
extern int __cdecl chk_fldpriv(long tabid,int colno,short priv,short reterr);
static int __cdecl auth_ok(char *user,long tabid,int colno,short priv,short *fldlevl);
extern void __cdecl dumpsqc(struct _S_SQCURSOR *sqc);
extern int __cdecl dumpqdesc(struct sqlda *q_desc,char *hdr,int indent,int dumpptrs);
extern int __cdecl dumpsqlvars(struct sqlvar_struct *sv,short n,char *hdr,int indent,int dumpptrs);
extern int __cdecl do_rebuild(struct _S_SQCURSOR *sqc);
static int __cdecl rebuild(struct _S_DBHEAD *pdbhead);
extern void __cdecl prep_rename(struct _S_SQCURSOR *sqc);
extern void __cdecl prp_rntable(struct _S_SQCURSOR *sqc);
extern void __cdecl exc_rntable(struct _S_SQCURSOR *sqc);
static void __cdecl prp_rncolumn(struct _S_SQCURSOR *sqc);
extern void __cdecl exc_rncolumn(struct _S_SQCURSOR *sqc);
extern void __cdecl copysellist(struct _S_SQCURSOR *sqc,struct _expr *oldexp,struct _expr *newexp,struct _structmap *smap,struct _frmtbl *newftp,int cpstrc);
extern void __cdecl copycond(struct _S_SQCURSOR *sqc,struct _cond *oldcnd,struct _cond *newcnd,struct _structmap *smap,struct _frmtbl *newftp,int cpstrc);
static int __cdecl cp2cond(struct _S_SQCURSOR *sqc,struct _cond *oldcnd,struct _cond *newcnd,struct _structmap *smap,struct _frmtbl *newftp,int cpstrc);
static int __cdecl copybterm(struct _S_SQCURSOR *sqc,struct _bterm *oldbtrm,struct _bterm *newbtrm,struct _structmap *smap,struct _frmtbl *newftp,int cpstrc);
static int __cdecl copyexp(struct _S_SQCURSOR *sqc,struct _expr *oldexp,struct _expr *newexp,struct _structmap *smap,struct _frmtbl *newftp,int clstype,int cpstrc);
static int __cdecl copyterm(struct _S_SQCURSOR *sqc,struct _term *oldtrm,struct _term *newtrm,struct _structmap *smap,struct _frmtbl *newftp,int clstype,int cpstrc);
static int __cdecl copydtexp(struct _S_SQCURSOR *sqc,struct _dtexpr *olddtexp,struct _dtexpr *newdtexp,struct _structmap *smap,struct _frmtbl *newftp,int clstype,int cpstrc);
extern void __cdecl copyfldlist(struct _S_SQCURSOR *sqc,struct _fldlist *oldflst,struct _fldlist *newflst,struct _expr *oldexp,struct _expr *newexp,struct _structmap *smap,struct _frmtbl *newftp,int clstype,int cpstrc);
extern void __cdecl remap_flds(struct _S_SQCURSOR *sqc,struct _select *sel,struct _structmap *smap,struct _frmtbl *newftp,short crtlist);
static int __cdecl map_expflds(struct _S_SQCURSOR *sqc,struct _expr *ep,struct _structmap *smap,struct _frmtbl *newftp,int clstype,int crtlist);
static int __cdecl map_whereflds(struct _S_SQCURSOR *sqc,struct _cond *cond,struct _structmap *smap,struct _frmtbl *newftp,int clstype,int crtlist);
static void __cdecl map_listflds(struct _S_SQCURSOR *sqc,struct _fldlist *flst,struct _structmap *smap,struct _frmtbl *newftp,int clstype,int crtlist);
static void __cdecl map_newfld(struct _S_SQCURSOR *sqc,struct _S_SFIELD *fld,struct _structmap *smap,struct _frmtbl *newftp,int clstype,int crtlist);
static int __cdecl map_fptr(struct _S_SQCURSOR *sqc,struct _S_SFIELD *fld,struct _frmtbl *newftp,struct _structmap *fmap,int clstype,int crtlist);
static int __cdecl initcursorlist(void);
extern int __cdecl addcursorlist(char *crsname,struct _S_SQCURSOR *sqc,int cursstat);
extern int __cdecl delcursorlist(struct _S_SQCURSOR *sqc);
extern void __cdecl curs_id(struct _S_SQCURSOR *sqc);
static struct _S_SQCURSOR *__cdecl getcrsptr(char *crsname);
extern char *__cdecl getcrsnam(struct _S_SQCURSOR *sqc);
extern void __cdecl closenohold(void);
extern void __cdecl exec_select(struct _S_SQCURSOR *sqc);
extern int __cdecl alwaysfalse(struct _cond *cond);
extern struct _select *__cdecl grpby_to_tmp(struct _S_SQCURSOR *sqc,struct _select *sel);
extern void __cdecl pretmpread(struct _S_SQCURSOR *sqc,struct _select *sel,int reduce);
extern int __cdecl frmtbl_row(struct _S_SQCURSOR *sqc,struct _select *sel,struct sqlda *q_desc,int outrow,int reduce);
extern int __cdecl chk_lastagg(struct _S_SQCURSOR *sqc,struct _select *sel,struct sqlda *q_desc,int outrow);
static struct _select *__cdecl bld_grpsel(struct _S_SQCURSOR *sqc,struct _select *oldsel);
static struct _select *__cdecl tmpselinit(struct _S_SQCURSOR *sqc,struct _select *oldsel,struct _S_DBHEAD *tmptp);
static int __cdecl ftstart(struct _S_SQCURSOR *sqc,struct _select *sel,struct _frmtbl *ftp);
extern int __cdecl next_row(struct _S_SQCURSOR *sqc,struct _select *sel,struct _frmtbl *origftp,int reduce);
static int __cdecl selread(struct _frmtbl *ftp,short nextmode,int *endbrk);
static int __cdecl inbracket(struct _frmtbl *ftp);
static int __cdecl resetrows(struct _select *sel,short *i);
static int __cdecl resetouter(struct _select *sel,struct _frmtbl *ftp,short *i);
static int __cdecl setoutnull(struct _select *sel,short outgroup,int nullflag);
static int __cdecl outreadyout(struct _select *sel,struct _frmtbl *ftp,short *tblnum);
static int __cdecl outotherout(struct _select *sel,short accessord);
static int __cdecl isoutparent(struct _select *sel,short outparent,short outgroup);
static int __cdecl resetbrack(struct _select *sel,short ordno);
static int __cdecl chk_gbreak(struct _S_SQCURSOR *sqc,struct _select *sel,struct sqlda *q_desc,int outrow,int firstread);
static int __cdecl switchgrpvals(struct _select *sel);
extern void __cdecl sel_line(struct _S_SQCURSOR *sqc,struct _select *sel,struct sqlda *q_desc);
extern void __cdecl upd_line(struct _S_SQCURSOR *sqc,struct _select *sel);
extern int __cdecl updputdf(struct sqlvar_struct *col,struct _S_DBFIELD *fp);
static int __cdecl pregrp_line(struct _S_SQCURSOR *sqc,struct _select *sel);
extern void __cdecl tmp_line(struct _S_SQCURSOR *sqc,struct _select *sel,struct sqlda *q_desc);
static int __cdecl out_line(struct _S_SQCURSOR *sqc,struct _select *sel,struct _S_DBHEAD *tp);
extern void __cdecl starttmp(struct _S_DBHEAD *tmptp);
extern int __cdecl tmp_row(struct _S_SQCURSOR *sqc,struct _select *sel,int direct,struct sqlda *q_desc,int outtmp);
static int __cdecl val_to_fpunl(struct _S_SQCURSOR *sqc,struct _expr *ep,struct _S_DBFIELD *fp,struct _S_VALUE *val,short fsize);
static int __cdecl nowriterr(struct _S_SQCURSOR *sqc,struct _S_DBFIELD *fp);
static int __cdecl eval_bool(struct _S_SQCURSOR *sqc,struct _select *sel,struct _cond *cond,short selnum,short tblnum,short maxouter);
static int __cdecl evalbterm(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bterm *bterm,short selnum,short tblnum,short maxouter);
static int __cdecl isoutnull(struct _bfactor *bfact);
static int __cdecl isoutexp(struct _expr *exp);
static int __cdecl isoutterm(struct _term *trm);
extern int __cdecl evalbfact(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bfactor *bfact,short selnum,short tblnum);
static int __cdecl evalposbf(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bfactor *bfact,short selnum,short tblnum,short *nulloprnd);
extern void __cdecl subquery(struct _S_SQCURSOR *sqc,struct _bfactor *bfact);
static short __cdecl subselexec(struct _S_SQCURSOR *sqc,struct _select **sel ,struct _bfactor *bfact,short bop,short qop);
static struct _select *__cdecl bld_subsel(struct _S_SQCURSOR *sqc,struct _select *oldsel);
static int __cdecl matchstr(short bop,char *s1,char *s2);
static int __cdecl matchc(char c,char *str,int *j);
extern int __cdecl eval_exp(struct _S_SQCURSOR *sqc,struct _select *sel,struct _expr *ep,struct _S_VALUE *val,short selnum,short tblnum);
extern int __cdecl eval_term(struct _S_SQCURSOR *sqc,struct _select *sel,struct _term *term,struct _S_VALUE *val,short selnum,short tblnum);
static int __cdecl eval_fact(struct _S_SQCURSOR *sqc,struct _select *sel,struct _S_FACTOR *fact,short selnum,short tblnum);
static void __cdecl eval_aggreg(struct _S_FACTOR *fact,struct _select *sel);
static int __cdecl eval_dtfunc(struct _S_FACTOR *fact,short selnum,short tblnum);
static int __cdecl evaldate(struct _dtexpr *dtexp,short selnum,short tblnum);
static void __cdecl get_flddata(struct _S_SFIELD *fld,struct _S_VALUE *val);
static int __cdecl ag_accum(struct _S_SQCURSOR *sqc,struct _select *sel,int firstread);
static void __cdecl agac_exp(struct _S_SQCURSOR *sqc,struct _select *sel,struct _expr *ep,int accum);
static int __cdecl agac_term(struct _S_SQCURSOR *sqc,struct _select *sel,struct _term *term,int accum);
static void __cdecl agac_fact(struct _S_SQCURSOR *sqc,struct _select *sel,struct _S_FACTOR *fact,int accum);
static void __cdecl agac_cond(struct _S_SQCURSOR *sqc,struct _select *sel,struct _cond *cond,int accum);
static int __cdecl agacbterm(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bterm *term,int accum);
static int __cdecl agacbfact(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bfactor *fact,int accum);
extern int __cdecl optimaggreg(struct _S_SQCURSOR *sqc,struct _select *sel,struct sqlda *q_desc,int outrow);
static int __cdecl resettblcurs(struct _select *sel);
extern int __cdecl fmtfield(char *s1,char *s2,short sqltype,short fxtype,short length,int dec,int justify);
extern void __cdecl setoptinfo(struct _S_SQCURSOR *sqc,struct _select *sel);
extern struct _cond *__cdecl setselopt(struct _S_SQCURSOR *sqc,struct _select *sel);
extern void __cdecl opt_info(struct _S_SQCURSOR *sqc,struct _bfactor *bfact,struct _expr *ep);
static void __cdecl add_optinfo(struct _S_SQCURSOR *sqc,struct _bfactor *bfact,struct _S_SFIELD *fld,short etype);
extern void __cdecl init_optinfo(struct _optiminfo *ofp,struct _S_SFIELD *fld);
extern struct _cond *__cdecl chk_always(struct _S_SQCURSOR *sqc,struct _cond *cond);
static int __cdecl chk_constexp(struct _S_SQCURSOR *sqc,struct _bfactor *fact);
static int __cdecl set_bracket(struct _S_SQCURSOR *sqc,struct _bfactor *bfact,struct _S_DBFIELD *fp);
extern struct _bfactor *__cdecl set_dynabrk(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bfactor *bfact,struct _S_DBFIELD *fp);
extern int __cdecl fldinbrack(struct _S_DBFIELD *fp1,struct _bfactor *bfact);
extern void __cdecl brkfree(struct _bracket *brk);
static int __cdecl brksvalfree(struct _S_VALUE *val);
static int __cdecl brk_list(struct _S_SQCURSOR *sqc,struct _bfactor *bfact,struct _listv *vlist,short dynabrk);
static int __cdecl add_bracket(struct _S_SQCURSOR *sqc,struct _bfactor *bfact,struct _bracket *curbrk,struct _bracket *prevbrk,struct _S_VALUE *begval,short bincl,struct _S_VALUE *endval,short eincl);
static int __cdecl save_bracket(struct _S_SQCURSOR *sqc,struct _bracket *curbrk,struct _S_VALUE *begval,short bincl,struct _S_VALUE *endval,short eincl);
static void __cdecl save_opbrk(struct _S_SQCURSOR *sqc,struct _bfactor *bfact,struct _bracket *curbrk,struct _bracket *prevbrk,struct _S_VALUE *val,int relbeg,int relend,short relval);
static struct _bracket *__cdecl link_brk(struct _S_SQCURSOR *sqc,struct _bfactor *bfact,struct _bracket *curbrk,struct _bracket *prevbrk);
static int __cdecl new_begbrk(struct _S_SQCURSOR *sqc,struct _bracket *brk,struct _S_VALUE *begval,short bincl);
static int __cdecl new_endbrk(struct _S_SQCURSOR *sqc,struct _bracket *brk,struct _S_VALUE *endval,short eincl);
static void __cdecl find_endbrk(struct _S_SQCURSOR *sqc,struct _bracket *brk,struct _S_VALUE *endval);
static int __cdecl simple_bool(struct _S_SQCURSOR *sqc,struct _bfactor *bfact,struct _S_DBFIELD *fp,struct _S_VALUE *val1,short *boolop);
static int __cdecl fldinexp(struct _S_DBFIELD *fp,struct _expr *ep, int godeep);
static int __cdecl fldinfact(struct _S_DBFIELD *fp,struct _S_FACTOR *fact, int godeep);
static int __cdecl smple_exp(struct _S_SQCURSOR *sqc,struct _expr *ep,struct _S_FACTOR *fldfact,struct _S_VALUE *val);
static short __cdecl revop(short op);
static int __cdecl brk_match(struct _S_SQCURSOR *sqc,struct _bfactor *bfact,struct _listv *lv);
static struct _listv *__cdecl matchrange(struct _S_SQCURSOR *sqc,struct _listv *lv,char *begp,short len,char *endp,short *initlv);
static struct _listv *__cdecl list_match(struct _S_SQCURSOR *sqc,struct _listv *lv,char *str,short len,short *initlv);
extern int __cdecl isconstbrk(struct _optiminfo *opt);
extern int __cdecl isdynabrk(struct _optiminfo *opt);
static int __cdecl brkintersect(struct _S_SQCURSOR *sqc,struct _optiminfo *opt1,struct _optiminfo *opt2,short dynabrk);
extern struct _bfactor *__cdecl brkunion(struct _S_SQCURSOR *sqc,struct _optiminfo *opt,struct _S_DBFIELD *fp,struct _cond *rcond,short dynabrk);
static int __cdecl brackinfact(struct _S_SQCURSOR *sqc,struct _S_SFIELD *fld,struct _bfactor *bfact,short dynabrk);
static int __cdecl brk2union(struct _S_SQCURSOR *sqc,struct _optiminfo *opt1,struct _optiminfo *opt2);
static struct _bracket *__cdecl crtcopybrack(struct _S_SQCURSOR *sqc,struct _bracket *brk1);
extern void __cdecl sel_stmt(struct _S_SQCURSOR *sqc,struct _select *sel);
extern void __cdecl query_spec(struct _S_SQCURSOR *sqc,struct _select *sel,int *nxtclause);
extern short __cdecl sel_clause(struct _S_SQCURSOR *sqc);
static int __cdecl sel_list(struct _S_SQCURSOR *sqc,struct _expr *expr);
extern int __cdecl sel_lsexpr(struct _S_SQCURSOR *sqc,struct _expr *expr);
static short __cdecl is_alltbl(struct _S_SQCURSOR *sqc,struct _expr *expr);
extern void __cdecl other_select_clauses(struct _S_SQCURSOR *sqc,struct _select *sel,int gotfrom,int *nxtclause);
static int __cdecl table_list(struct _S_SQCURSOR *sqc,struct _select *sel,struct _frmtbl *ftp,short outgroup,short outparent,short *outercnt);
static int __cdecl out_tbl_spec(struct _S_SQCURSOR *sqc,struct _select *sel,struct _frmtbl *ftp,short outgroup,short outparent,short *outercnt);
static int __cdecl tbl_spec(struct _S_SQCURSOR *sqc,struct _select *sel,struct _frmtbl *ftp,short outgroup,short outparent);
static int __cdecl optional_sel_cls(struct _S_SQCURSOR *sqc,struct _select *sel,int nxtclause);
static int __cdecl group_by_clause(struct _S_SQCURSOR *sqc,struct _select *sel,int nxtclause);
static int __cdecl grp_list(struct _S_SQCURSOR *sqc,struct _fldlist *grpfld);
extern short __cdecl agg_spec(struct _S_SQCURSOR *sqc,struct _S_SFIELD *fld);
static int __cdecl aggregate(struct _S_SQCURSOR *sqc);
static int __cdecl outer_query_clauses(struct _S_SQCURSOR *sqc,struct _select *sel,int nxtclause);
static int __cdecl sort_clause(struct _S_SQCURSOR *sqc,struct _fldlist *sortfld);
static int __cdecl order_spec(struct _S_SQCURSOR *sqc,struct _fldlist *sortfld);
static int __cdecl sortby_spec(struct _S_SQCURSOR *sqc,struct _fldlist *sortfld,char *byclause);
extern short __cdecl is_char(struct _S_SQCURSOR *sqc,char ch,short required,short trail_sp);
extern short __cdecl iskeyword(struct _S_SQCURSOR *sqc,char *k,int required);
extern short __cdecl get_id(struct _S_SQCURSOR *sqc);
extern void __cdecl cp_mv_p(struct _S_SQCURSOR *sqc,char *str,short len);
extern void __cdecl skip_sp(struct _S_SQCURSOR *sqc);
extern int __cdecl end_stmt(struct _S_SQCURSOR *sqc,short required);
extern void __cdecl setsubpaths(struct _S_SQCURSOR *sqc,struct _select *sel);
static int __cdecl setaccesspath(struct _S_SQCURSOR *sqc,struct _select *sel);
extern void __cdecl set_obidx(struct _S_SQCURSOR *sqc,struct _select *sel,struct _fldlist *op);
static void __cdecl setobidx2(struct _S_SQCURSOR *sqc,struct _select *sel,struct _fldlist *op);
static int __cdecl orderbyalts(struct _S_SQCURSOR *sqc,struct _select *sel);
static int __cdecl obaltfact(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bfactor *bfact);
static int __cdecl grpby_in_idx(struct _fldlist *gfp1,struct _fldlist *gfp);
static int __cdecl gfinindex(struct _fldlist *gfp1,struct _fldlist *gfp,struct _S_DBFIELD *fp);
static int __cdecl orderbyidx(char *fldord,int nflds);
static int __cdecl obidx2(struct _S_SQCURSOR *sqc,struct _select *sel,struct _fldlist **ordflds ,int nobflds);
static int __cdecl initordfld(struct _ordfld *ofp,struct _S_DBFIELD *fp,short sortord);
static int __cdecl obidxfacts(struct _S_SQCURSOR *sqc,struct _select *sel,int tidx,int ntbls);
static int __cdecl adjtableord(struct _S_DBFIELD *fp,int tidx,int ntbls);
static int __cdecl addordjoinfld(struct _S_SQCURSOR *sqc,struct _joinlst *jfld,struct _ordfld *ofp);
static int __cdecl iseqbrack(struct _optiminfo *opt,struct _S_DBFIELD *fp,struct _S_VALUE *val,short isrowid);
static short __cdecl fldcorrelate(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bfactor *bfact,struct _S_DBFIELD *fp);
static int __cdecl geteqjoin(struct _S_SQCURSOR *sqc,struct _bfactor *bfact,struct _S_DBFIELD **fp1 ,struct _S_DBFIELD **fp2 );
static struct _bfactor *__cdecl unionbterm(struct _S_SQCURSOR *sqc,struct _select *sel,struct _optiminfo *opt,short joinout);
static struct _bfactor *__cdecl brkinalltrms(struct _S_SFIELD *fld,struct _select *sel,short *dynabrk,short joinout);
static int __cdecl factinalltrms(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bfactor *bfact,struct _S_DBFIELD *fp1,struct _S_DBFIELD *fp2,struct _S_VALUE *val,short isrowid);
extern int __cdecl matchnobrk(struct _bfactor *bfact);
static int __cdecl obidxcandidate(int tidx);
static int __cdecl obidxnextfact(int tidx,int fidx);
static int __cdecl obidxbackfact(int tidx,int ntbls);
static int __cdecl rewindordflds(int tidx,int fidx,int rwdflds);
static int __cdecl obidxreduceflds(int tidx);
static int __cdecl resetordflds(int tidx);
static int __cdecl getordbyidx(int tidx);
static int __cdecl bldordbyidx(char *fldord,int neflds);
static int __cdecl isobindex(short *dips,char *fldord,int nflds);
static struct _S_DBHEAD *__cdecl tmptblalloc(void);
static struct _S_DBHEAD *__cdecl tmpfldcreate(struct _S_DBHEAD *tpo,char *fldname,short type,short siz,short qual);
static struct _S_DBINDEX *__cdecl tmpidxinit(struct _S_SQCURSOR *sqc,struct _S_DBHEAD *tp,short uniq);
static int __cdecl tidxfldcrt(struct _S_DBHEAD *tp,struct _S_DBINDEX *ip,char *fldname,short asc_desc,int fldno);
static struct _S_DBHEAD *__cdecl wr_fldspecs(struct _S_DBHEAD *tmptp,struct _frmtbl *ftp);
static int __cdecl tmp4grp_spec(struct _S_SQCURSOR *sqc,struct _select *sel,struct _fldlist *sortflds);
static int __cdecl tmp4ob_spec(struct _S_SQCURSOR *sqc,struct _select *sel);
static struct _S_DBHEAD *__cdecl tmp_subqflds(struct _select *sel,struct _S_DBHEAD *tmptp,short autolblnum,int *reclen);
extern struct _select *__cdecl fill_temps(struct _S_SQCURSOR *sqc,struct _select *sel);
static struct _select *__cdecl fill_seltmps(struct _S_SQCURSOR *sqc,struct _select *sel);
static int __cdecl tmpbuild(struct _S_DBHEAD *tp);
static struct _select *__cdecl set_tmpstruct(struct _S_SQCURSOR *sqc,struct _select *oldsel,struct _frmtbl **ftp );
static void __cdecl set_joins(struct _S_SQCURSOR *sqc,struct _select *sel);
static int __cdecl jointblord(char *tblord,int ntbls);
static int __cdecl gettblidx(struct _S_TBLORD *otbl,int n,short table1);
static int __cdecl joincrit(struct _select *sel,struct _optiminfo *initopt,struct _optiminfo *curopt,struct _bfactor **bfact );
static int __cdecl joincrt2(struct _optiminfo *initopt,struct _optiminfo *curopt);
static int __cdecl size_tbls(struct _S_TBLORD *otbls,int ntbls);
static int __cdecl nxttblbysiz(int tbl1,int ntbls);
static int __cdecl gettbidx2(char *fldord,int nflds);
static void __cdecl idxtosubq(struct _S_SQCURSOR *sqc,struct _select *sel,struct _frmtbl *ftp);
static int __cdecl initsubqbrk(struct _bfactor *bfact);
static int __cdecl reinitindex(char *tblord,int ntbls);
static int __cdecl equalbrack(struct _optiminfo *opt1,struct _optiminfo *opt2);
extern int __cdecl equalexps(struct _expr *exp1,struct _expr *exp2);
static int __cdecl equalterms(struct _term *trm1,struct _term *trm2);
static int __cdecl equalfacts(struct _S_FACTOR *fct1,struct _S_FACTOR *fct2);
static int __cdecl equalfields(struct _S_SFIELD *fld1,struct _S_SFIELD *fld2);
static int __cdecl equaldtfuncs(struct _S_DTFUNC *dfnc1,struct _S_DTFUNC *dfnc2);
static int __cdecl equaldtexps(struct _dtexpr *dexp1,struct _dtexpr *dexp2);
static int __cdecl autocorrelate(struct _S_SQCURSOR *sqc,struct _select *sel);
extern void __cdecl mksubqbfact(struct _S_SQCURSOR *sqc,struct _bfactor *fact1,struct _S_SELINDEX *idxrel);
static void __cdecl tblaccessord(struct _select *sel);
extern int __cdecl shortcmp(const void *s1,const void *s2);
extern void __cdecl typecheck(struct _S_SQCURSOR *sqc);
extern void __cdecl chk_select(struct _S_SQCURSOR *sqc,struct _select *sel);
static int __cdecl chk_slist(struct _S_SQCURSOR *sqc,struct _select *sel);
extern void __cdecl cmp_dftoexp(struct _S_SQCURSOR *sqc,struct _select *sel,struct _S_DBFIELD *fp,struct _expr *ep);
static struct _expr *__cdecl expand_tblflds(struct _S_SQCURSOR *sqc,struct _frmtbl *ftp,struct _expr *curep,short *exprcnt);
extern void __cdecl fldfmtoffs(struct _S_DBFIELD *fp,short typ,struct _expr *ep);
extern void __cdecl fldlinktbl(struct _S_SQCURSOR *sqc,struct _frmtbl *ftp,struct _S_SFIELD *fld,int clstype);
static int __cdecl expr_type(struct _S_SQCURSOR *sqc,struct _select *sel,struct _expr *ep,int clstype);
static int __cdecl term_type(struct _S_SQCURSOR *sqc,struct _select *sel,struct _expr *ep,struct _term *trm,int clstype);
static void __cdecl fact_type(struct _S_SQCURSOR *sqc,struct _select *sel,struct _expr *ep,struct _S_FACTOR *fact,int clstype);
static int __cdecl chk_datexpr(struct _S_SQCURSOR *sqc,struct _select *sel,struct _expr *ep,struct _dtexpr *dtp,int clstype);
static void __cdecl chk_aggreg(struct _S_SQCURSOR *sqc,struct _expr *ep,struct _S_FACTOR *fact);
static void __cdecl mergetype(struct _S_SQCURSOR *sqc,struct _expr *e1,struct _expr *e2,char op);
static void __cdecl get_expfld(struct _expr *e1,struct _expr *e2);
static int __cdecl lkupfield(struct _S_SQCURSOR *sqc,struct _select *sel,struct _expr *ep,struct _S_SFIELD *fld,int clstype);
static struct _frmtbl *__cdecl lkupfromtbl(struct _S_SQCURSOR *sqc,struct _select *sel,char *tbl,char *owner,int clstype,int *outsel,char *textp);
static int __cdecl lkup_tfld(struct _S_SQCURSOR *sqc,struct _expr *ep,struct _S_DBHEAD *tp,struct _S_SFIELD *fld,short rpterr);
static struct _frmtbl *__cdecl lkup_ffld(struct _S_SQCURSOR *sqc,struct _select *origsel,struct _expr *ep,struct _S_SFIELD *fld,int clstype,int *outsel);
static int __cdecl chk_group(struct _S_SQCURSOR *sqc,struct _select *sel);
static int __cdecl grpby_expr(struct _fldlist *gf,struct _expr *ep);
static int __cdecl expfld_ingrp(struct _S_SQCURSOR *sqc,struct _expr *ep,struct _fldlist *glist);
static int __cdecl trmfld_ingrp(struct _S_SQCURSOR *sqc,struct _term *trm,struct _fldlist *glist,char *textp);
static void __cdecl fctfld_ingrp(struct _S_SQCURSOR *sqc,struct _S_FACTOR *fact,struct _fldlist *glist,char *textp);
static int __cdecl dtfld_ingrp(struct _S_SQCURSOR *sqc,struct _dtexpr *dtp,struct _fldlist *glist,char *textp);
static void __cdecl fld_ingrp(struct _S_SQCURSOR *sqc,struct _S_SFIELD *fld,struct _fldlist *gf,char *textp);
static int __cdecl uniq_to_grpby(struct _S_SQCURSOR *sqc,struct _select *sel);
static void __cdecl rm_dupe_grpby(struct _select *sel);
static int __cdecl chk_having(struct _S_SQCURSOR *sqc,struct _select *sel);
static void __cdecl cond_type(struct _S_SQCURSOR *sqc,struct _select *sel,struct _cond *cond,int btype);
static void __cdecl bterm_type(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bterm *trm,int btype);
static void __cdecl bfact_type(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bfactor *fact,int btype);
static int __cdecl comp_expcast(struct _S_SQCURSOR *sqc,struct _expr *lexp,struct _expr *rexp);
static int __cdecl comp_vlcast(struct _S_SQCURSOR *sqc,struct _expr *lexp,struct _S_VALUE *val);
extern int __cdecl comp_cast(struct _S_SQCURSOR *sqc,struct _S_VALUE *val,short nc_typ,short dtqual,char *eptext);
extern int __cdecl time_constant(struct _S_VALUE *val,short len);
static void __cdecl comp_listv(struct _S_SQCURSOR *sqc,struct _expr *ep,short type,char *vtype);
static void __cdecl chkouterjoin(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bfactor *fact);
static void __cdecl logjoinpair(struct _S_SQCURSOR *sqc,struct _expr *ep,short *outjoinpair);
static int __cdecl joinancestor(struct _select *sel,short outparent,short outergrp);
static void __cdecl chk_ordlist(struct _S_SQCURSOR *sqc);
static int __cdecl sfld_ordfld(struct _S_SQCURSOR *sqc,struct _select *sel,struct _fldlist *op,char *textp);
static int __cdecl samefield(struct _S_SFIELD *fld,struct _expr *ep);
static int __cdecl labl_ordfld(struct _S_SQCURSOR *sqc,struct _select *sel,struct _fldlist *op,char *textp);
static void __cdecl chk_grpidx(struct _S_SQCURSOR *sqc,struct _select *sel);
static int __cdecl reorg_group(struct _S_SQCURSOR *sqc,struct _select *sel);
extern void __cdecl prep_select(struct _S_SQCURSOR *sqc,char *selp);
static int __cdecl selparser(struct _S_SQCURSOR *sqc,char *selp);
static int __cdecl selsqcinit(struct _S_SQCURSOR *sqc,char *selp);
extern void __cdecl initslect(struct _select *sel);
extern void __cdecl initfrmtbl(struct _S_SQCURSOR *sqc,struct _select *sel,struct _frmtbl *ftp);
extern void __cdecl expression(struct _S_SQCURSOR *sqc,struct _expr *expr,short condtype);
static int __cdecl positive_expression(struct _S_SQCURSOR *sqc,struct _expr *expr,short condtype);
static int __cdecl term(struct _S_SQCURSOR *sqc,struct _expr *expr,struct _term *trm,short condtype);
static void __cdecl factor(struct _S_SQCURSOR *sqc,struct _expr *expr,struct _S_FACTOR *fact,short condtype);
extern int __cdecl keyword_var(struct _S_SQCURSOR *sqc,short *type);
extern void __cdecl todayval(struct _S_VALUE *val);
static int __cdecl date_func(struct _S_SQCURSOR *sqc);
static int __cdecl date_exp(struct _S_SQCURSOR *sqc,struct _dtexpr *dp);
static void __cdecl num_date_term(struct _S_SQCURSOR *sqc,struct _dtexpr *dp);
extern int __cdecl fact_hostq(struct _S_SQCURSOR *sqc,struct _S_FACTOR *fact,struct _expr *expr);
static int __cdecl field_exp(struct _S_SQCURSOR *sqc,struct _S_SFIELD *fld);
extern int __cdecl fld_spec(struct _S_SQCURSOR *sqc,struct _S_SFIELD *fld);
extern int __cdecl constant(struct _S_SQCURSOR *sqc,struct _S_VALUE *val,short sign,short *dec);
extern int __cdecl num_constant(struct _S_SQCURSOR *sqc,struct _S_VALUE *val,short sign,short *dec);
extern int __cdecl str_constant(struct _S_SQCURSOR *sqc,struct _S_VALUE *val,short *len,int wildc);
static char *__cdecl scan_copy(char *p1,char *p2,short *len,char qtch,int wildc);
extern int __cdecl digit_seq(struct _S_SQCURSOR *sqc);
static int __cdecl add_op(struct _S_SQCURSOR *sqc,char *op);
static int __cdecl mult_op(struct _S_SQCURSOR *sqc,char *op);
extern char *__cdecl sqdbuf_alloc(struct _S_SQCURSOR *sqc,struct sqlda *q_desc,int attachcurs);
extern int __cdecl sqwfmread(struct _S_DBHEAD *pdbhead,int mode);
extern int __cdecl sqwfmwrite(struct _S_DBHEAD *pdbhead);
extern void __cdecl tablealloc(struct _S_SQCURSOR *sqc);
static int __cdecl seltblload(struct _S_SQCURSOR *sqc,struct _select *sel,short priv);
static int __cdecl selcondload(struct _S_SQCURSOR *sqc, struct _cond *cond);
extern void __cdecl tblunload(struct _select *sel);
extern int __cdecl traceinit(char *argv);
static int __cdecl traceopen(int fd,char *prefix);
extern int __cdecl traceclose(void);
extern void __cdecl dumpstruct(struct _S_SQCURSOR *sqc,int phase);
extern void __cdecl dumpsqltbl(struct _S_SQCURSOR *sqc,int fd);
extern void __cdecl dumpsqlfld(struct _S_SQCURSOR *sqc,int fd,char *hdr,struct _sqlfield *mdf,int indent);
extern void __cdecl dumphosts(int fd,struct _hosthdr *hosth);
extern void __cdecl dumpselect(struct _S_SQCURSOR *sqc,int fd,struct _select *sel,int indent);
extern void __cdecl dumpselexp(struct _S_SQCURSOR *sqc,int fd,struct _expr *ep,int indent);
extern void __cdecl dumpterm(struct _S_SQCURSOR *sqc,int fd,struct _term *term,int indent);
extern void __cdecl dumpfact(struct _S_SQCURSOR *sqc,int fd,struct _S_FACTOR *fact,int indent);
extern void __cdecl dumpdtexp(struct _S_SQCURSOR *sqc,int fd,char *name,struct _dtexpr *dtexp,int indent);
extern void __cdecl dumpfield(struct _S_SQCURSOR *sqc,int fd,struct _S_SFIELD *fld,int indent);
extern void __cdecl dumptable(struct _S_SQCURSOR *sqc,int fd,struct _frmtbl *tbl,int indent);
extern void __cdecl dumpselflds(int fd,struct _selflds *sfp,int indent);
extern void __cdecl dumpcond(struct _S_SQCURSOR *sqc,int fd,char *name,struct _cond *cond,int indent);
extern void __cdecl dumpbfact(struct _S_SQCURSOR *sqc,int fd,struct _bfactor *bf,char *name,int indent);
extern void __cdecl dumpvlist(int fd,struct _listv *lv,char *hdr,int indent);
extern void __cdecl dumpoptim(int fd,struct _optiminfo *optim,int indent);
extern void __cdecl dumpbrack(int fd,struct _bracket *brk,char *name,int indent);
extern void __cdecl dumpfldlist(struct _S_SQCURSOR *sqc,int fd,struct _fldlist *fld,int indent);
extern void __cdecl dumpfldnam(int fd,struct _S_DBFIELD *fp,char *name,int indent);
extern void __cdecl dumpsortfield(struct _S_SQCURSOR *sqc,int fd,struct _select *sel,int indent);
extern void __cdecl dumpordtbls(struct _S_SQCURSOR *sqc,int fd,struct _S_TBLORD *ordtbls,short ntbls,short factsonly,char *where);
static int __cdecl dumpordflds(struct _S_SQCURSOR *sqc,int fd,struct _ordfld *ofp,int i,short factsonly,char *name,int indent);
static int __cdecl ptrerr(int sig);
extern void __cdecl setdmpphs(int phase);
extern void __cdecl pr_ptr(struct _S_SQCURSOR *sqc,char *where);
extern void __cdecl dumpdec(struct decimal *dec);
extern void __cdecl dumpdtime(struct dtime *dt);
extern void __cdecl dumpdbl(double *dbl);
extern void __cdecl dumpfxtype(int fd,char *name,short type,int indent);
extern void __cdecl dumpval(int fd,char *name,struct _S_VALUE *val,int indent);
extern void __cdecl prp_startlog(struct _S_SQCURSOR *sqc);
extern int __cdecl exc_startlog(struct _S_SQCURSOR *sqc);
extern int __cdecl prp_beginwk(struct _S_SQCURSOR *sqc);
extern int __cdecl prp_commitwk(struct _S_SQCURSOR *sqc);
extern int __cdecl prp_rollback(struct _S_SQCURSOR *sqc);
extern int __cdecl prp_rfwddb(struct _S_SQCURSOR *sqc);
extern int __cdecl exc_rfwddb(struct _S_SQCURSOR *sqc);
extern int __cdecl gettransmode(short nolog);
extern int __cdecl getnologmode(short nolog);
extern void __cdecl prep_unld(struct _S_SQCURSOR *sqc);
extern int __cdecl exc_unld(struct _S_SQCURSOR *sqc);
extern void __cdecl prep_update(struct _S_SQCURSOR *sqc);
extern void __cdecl upd_stmt(struct _S_SQCURSOR *sqc);
static int __cdecl upd_spec(struct _S_SQCURSOR *sqc);
static void __cdecl set_list(struct _S_SQCURSOR *sqc,struct _sqlfield *modf,struct _expr *expr);
static void __cdecl assignment(struct _S_SQCURSOR *sqc,struct _sqlfield *modf,struct _expr *expr);
static int __cdecl assig_tuple(struct _S_SQCURSOR *sqc,struct _sqlfield *modf);
static int __cdecl field_list(struct _S_SQCURSOR *sqc,struct _sqlfield *modf);
static int __cdecl field_id(struct _S_SQCURSOR *sqc,struct _sqlfield *modf);
static int __cdecl expr_list(struct _S_SQCURSOR *sqc,struct _sqlfield *modf,struct _expr *prevep);
static int __cdecl set_subquery(struct _S_SQCURSOR *sqc,struct _sqlfield **modfaddr );
extern void __cdecl chk_setflds(struct _S_SQCURSOR *sqc);
static int __cdecl cmp_updtype(struct _S_SQCURSOR *sqc,struct _select *sel,struct _sqlfield *modf,struct _expr *ep);
extern void __cdecl updatecurr(struct _S_SQCURSOR *sqc,struct _select *sel);
extern void __cdecl openupdtbl(struct _S_SQCURSOR *sqc,struct _select *sel);
extern int __cdecl readupdtbl(struct _select *sel);
extern void __cdecl aftreadahead(struct _select *sel,int retval);
extern void __cdecl prp_updstat(struct _S_SQCURSOR *sqc);
extern void __cdecl exc_updstat(struct _S_SQCURSOR *sqc);
extern void __cdecl valstartup(void);
extern void __cdecl val_init(struct _S_VALUE *val);
extern void __cdecl valgetdf(struct _S_VALUE *val,struct _S_DBFIELD *fp);
extern void __cdecl strvalinit(struct _S_SQCURSOR *sqc,struct _S_VALUE *val,short len,char *func,char *what);
extern void __cdecl dtvalinit(struct _S_SQCURSOR *sqc,struct _S_VALUE *val,char *func,char *what);
static char *__cdecl val_getp(struct _S_VALUE *val,short type);
extern int __cdecl valputdf(struct _S_VALUE *val,struct _S_DBFIELD *fp);
extern int __cdecl sqlda_to_val(struct sqlvar_struct *qvar,struct _S_VALUE *val);
extern void __cdecl val_to_sqlda(struct _expr *ep,struct _S_VALUE *val,struct sqlvar_struct *qvar);
extern void __cdecl val_cast_sqlda(struct _S_VALUE *val,struct sqlvar_struct *qvar);
extern void __cdecl setindic(struct sqlvar_struct *qvar,short indic);
extern void __cdecl valformat(struct _S_VALUE *val,char *buf,int len,int dec,int justify);
extern void __cdecl valnull(struct _S_VALUE *val);
extern short __cdecl valtoshort(struct _S_VALUE *val);
extern long __cdecl valtolong(struct _S_VALUE *val);
extern float __cdecl valtoflt(struct _S_VALUE *val);
extern double __cdecl valtodbl(struct _S_VALUE *val);
extern int __cdecl valcmp(struct _S_VALUE *val1,struct _S_VALUE *val2);
extern void __cdecl valcopy(struct _S_SQCURSOR *sqc,struct _S_VALUE *srcval,struct _S_VALUE *destval,int cptype,char *func,char *what);
extern void __cdecl valarith(struct _S_VALUE *v1,char op,struct _S_VALUE *v2,struct _S_VALUE *vres);
extern void __cdecl getmaxval(struct _S_VALUE *val,short type);
extern void __cdecl getminval(struct _S_VALUE *val,short type);
static void __cdecl getlimit(struct _S_VALUE *val,short type,struct _S_LIMITS *lims);
extern int __cdecl ismaxval(struct _S_VALUE *val);
extern int __cdecl isminval(struct _S_VALUE *val);
extern void __cdecl negval(struct _S_VALUE *val);
static int __cdecl limitcmp(struct _S_VALUE *val,struct _S_LIMITS *lims);
static struct decimal *__cdecl getlimdec(struct _S_LIMITS *lims,short type);
extern int __cdecl nvalfitfld(struct _S_VALUE *val,struct _S_DBFIELD *fp);
extern int __cdecl getvvtlen(struct _S_VALUE *val);
extern int __cdecl dtcvval(char *sval,struct _S_VALUE *val,short dtqual);
extern void __cdecl where_clause(struct _S_SQCURSOR *sqc,struct _select *sel);
extern void __cdecl condition(struct _S_SQCURSOR *sqc,struct _select *sel,struct _cond *cond,short condtype);
static int __cdecl bool_term(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bterm *trm,short condtype);
static void __cdecl bool_factor(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bfactor *fact,short condtype);
static int __cdecl is_bool_paren(char *p);
static void __cdecl predicate(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bfactor *fact,short condtype);
static void __cdecl cmparison(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bfactor *fact,short condtype);
extern short __cdecl invbop(short op);
static short __cdecl invqop(short op);
static int __cdecl col1_query_spec(struct _S_SQCURSOR *sqc,struct _select *sel,struct _bfactor *fact);
static int __cdecl cnstant_list(struct _S_SQCURSOR *sqc,struct _listv *listv,struct _expr *expr);
static struct _listv *__cdecl const_list_expr(struct _S_SQCURSOR *sqc,struct _listv *listv,struct _expr *expr);
static void __cdecl end_range_const(struct _S_SQCURSOR *sqc,struct _listv *listv,struct _expr *expr);
static int __cdecl between_range(struct _S_SQCURSOR *sqc,struct _bfactor *fact);
extern int __cdecl vl_hostq(struct _S_SQCURSOR *sqc,struct _listv *listv,struct _expr *expr);
static short __cdecl comp_op(struct _S_SQCURSOR *sqc,struct _bfactor *fact);
